<?php define("CAMBIO", true); 

$stimer = explode( ' ', microtime() );
$stimer = $stimer[1] + $stimer[0];

// config file
include_once ('../config/config.php');
include_once ('../config/config.design.php');
include_once ('../config/config.advanced.php');

// create config class
$cf = new WH_ConfigAdvanced();

if (!$_GET) {
	header("Location: ../index.php?id=$cf->whLoginPage");
}

if (!$_SESSION["isa"]) { ?>
	<script type="text/javascript">hideAdmin();alert("Your session has expired, to continue editing this website, please re-login.");document.location.href = "<?php echo "index.php?id=$cf->whLoginPage"; ?>";</script>
<?php exit(); 
}

// function to scan dirs (php < 5)
if(!function_exists('scandir')) {
    function scandir($dir, $sortorder = 0) {
        if(is_dir($dir) && $dirlist = @opendir($dir)) {
            while(($file = readdir($dirlist)) !== false) {
                $files[] = $file;
            }
            closedir($dirlist);
            ($sortorder == 0) ? asort($files) : rsort($files); // arsort was replaced with rsort
            return $files;
        } else return false;
    }
}

// look for php files in cms/include directory
$includes = scandir('../cms/includes/');
foreach ($includes as $file) {
	if (substr($file,-4,4) == ".php") {
		// load class
		include('../cms/includes/'.$file);
	}
}


// init db
$db = new WH_Database();
if ($db->init($cf->whDatabase, $cf->whDbUser, $cf->whDbPass)==false) {
	WH_HTML::writeError('Kan niet connecten naar database', true);
}
$db->auto_slashes = true;

// load mainframe properties
$wh = new WH_Mainframe();
$wh->pages = WH_Pages::getInstance();
$wh->modules = WH_Modules::getInstance();
$wh->layouts = WH_Layouts::getInstance();

// get module id
$modid = WH_Helper::get('modid');
$module = WH_Helper::get('module');

if ($modid) {
	// load module by id
	$module = $wh->modules->$modid;
} elseif ($module) {
	// load module by name
	if (($modid = $wh->modules->getAdminModuleId($module))) {
		$module = $wh->modules->$modid;
	} elseif (($modid = $wh->modules->getModuleId($module))) {
		$module = $wh->modules->$modid;
	} else {
		// load fake module array
		$module = (object) Array("module"=>WH_Helper::get('module'));
	}
} else {
	// load fake module array
	$module = (object) Array("module"=>WH_Helper::get('module'));
}	

$cd = new WH_Document(null);
// html titel
$cd->htmltitel = "CMS: $module->module - ".$cf->whSitename;
// get task
$cd->task = WH_Helper::get('task');
// user id
// user params
$cd->uid = WH_Helper::get('uid','session');
$cd->tid = WH_Helper::get('tid','session');
$cd->isa = WH_Helper::get('isa','session');
// set admin bit
$cd->isadmin = true;
// check whether user exists and hashes are correct
if (!$cd->checkLogin($cd->uid, true)) {
	// log user out
	$cd->uid = null;
}

// set document language
$cd->setLang();

// include admin module
$modpath = '../modules/'.$module->module.'/'.$module->module.'.admin.php';
if (file_exists($modpath)) {
	include($modpath);
} else {
	die("Module file $modpath not found");
}

// define function to run
$className = 'WH_AdminModule'.$module->module;
$taskfunc =& new $className($module);

$output = "";

// loading def template
include('../tmpl/_default/tmpl.php');

// get task
$task = WH_Helper::get('task');

// set task to display if no task has been specified
if (!$task) { $task = "display"; }

// dynamic module task splitter
if ($module->module == "dynamic") {
	$taskarray = explode("_", $task);
	$task = $taskarray[0];
	if (count($taskarray)==2) {
		$taskfunc->subtask = $taskarray[1];
	}
	if (!$taskfunc->subtask) { $taskfunc->subtask = "display"; }
}

// prepare output
header("Cache-Control: no-cache, must-revalidate"); // HTTP/1.1
header("Expires: Sat, 26 Jul 1997 05:00:00 GMT"); // Date in the past

// run function
ob_start();
$taskfunc->$task();
$tmplContents = ob_get_clean();
ob_end_clean();	

// buffer html layout (AJAX)

foreach ($cd->warnings as $warning) {
	$output .= "<div class=\"warning\"><b>Warning:</b> ".$warning."</div>";
}

foreach ($cd->messages as $msg) {
	$output .= "<div class=\"message\"><b>Message:</b> ".$msg."</div>";
}
	
$output .= $tmplContents;

// update links in output

$updatelinks = "<script language=\"javascript\">initLang();</script>";
if (WH_Helper::get('show')!='module') {
	$output .= $updatelinks;
}

// write buffer, but compress first, for scripts don't work with multiline script objects in html code, php v5?
// drawback: 
// $output = WH_HTML::compress_html($output);
echo $output;

$etimer = explode( ' ', microtime() );
$etimer = $etimer[1] + $etimer[0];

if ($cf->whDebug && WH_Helper::get('show')!='module') {
	echo '<p style="margin:auto; text-align:center">';
	printf( "Database queries: <b>%s</b> <br/>", $db->counter);
	printf( "Script timer: <b>%f</b> seconds.", ($etimer-$stimer) );
	echo '</p>';
}

?>