<?php
/**
 * Cambio v0.5a
 * 
 * http://cambiocms.org/
 * @package Cambio
 */
if (defined("CAMBIO") or die("Access error"));

class WH_Pages {
	
	/**
	 * Pages class for WH website
	 *
	 * @return WH_Pages
	 */
	function WH_Pages($id = NULL) {
		return $this->_init($id);
	}
	
	function _init($id = NULL) {
		// initialize
		global $db;
		$db->select("SELECT * FROM pagina ORDER BY ordering ASC");
		$results = $db->get_obj();
		foreach ($results as $result) {
			$this->{$result->id} = new WH_Page($result);
		}
		// return pages
		return $this->getPages($id);
	}
	
	/**
	 * Get instance creating one if necessary
	 *
	 * @param integer $id
	 * @return WH_Pages
	 */
	function getInstance($id = NULL) {
		static $instance;
		if (!isset($instance)) {
			$instance = new WH_Pages();
		}
		if (!is_null($id)) {
			return $instance->getPages($id);
		} else {
			return $instance;
		}
	}
	
	function getPages($id = NULL) {
		if (!is_null($id)) {
			if ($this->$id) {
				return $this->$id;
			} else {
				return false;
			}
		} else {
			return $this;	
		}
	}
	
	function getPagesTree($id = NULL, $flat = false, $level = 0) {
		global $wh;		
		$tree = Array();
		// get main items
		foreach ((array) $wh->pages as $page) {
			if ((!$page->parent_id && is_null($id)) || $page->parent_id == $id) {
				if ($flat) {
					$page->level = $level;
					$tree[] = $page;
					$children = $wh->pages->getPagesTree($page->id, $flat, $level + 1);					
					foreach ($children as $child) {
						$tree[] = $child;
					}
				} else {
					$page->level = $level;
					$page->children = $wh->pages->getPagesTree($page->id, $flat, $level + 1);
					$tree[] = $page;
				}
			}
		}
		return $tree;
	}
	
}