<?php
/**
 * Cambio v0.5a
 * 
 * http://cambiocms.org/
 * @package Cambio
 */
if (defined("CAMBIO") or die("Access error"));

class WH_Cache {
	
	/**
	 * Cache class for WH website
	 *
	 * @return WH_Cache
	 */
	function WH_Cache() {
		// initialize
		//return $this;
	}
	
	function getCache($type, $data, $extension, $folder = NULL) {
		switch ($type) {
			case "filearray":
				global $wh, $db;
				// debug
				//WH_HTML::dump($data);
				if (!$data) {
					return false;
				}
				// set vars
				$filenamehash = "";
				$timehash = "";
				// loop data and make hashes
				foreach ($data as $item) {
					$timehash .= filemtime($item);
					$filenamehash .= $item;
				}
				$filenamehash = md5($filenamehash);
				$timehash = md5($timehash);
				// look in database for cache entry for filenamehash
				$cachefile = null;
				foreach ($wh->cache as $cache) {
					if ($cache->filenamehash == $filenamehash) {
						// does cache file exists?
						if (file_exists($cache->cachefile)) {
							if ($cache->timehash == $timehash) {
								//echo "cache";
								// cache file!
								return $cache->cachefile;
							} else {
								//echo "update";
								// file exists, but is older, first delete old one and write new!
								unlink($cache->cachefile);
								$newcachefile = WH_Cache::makeCacheFileName($filenamehash, $timehash, $extension, $folder);
								WH_Cache::saveFilesToCache($data, $newcachefile);
								$db->update_array("cache", Array("timehash"=>$timehash, "cachefile"=>$newcachefile),"filenamehash = '$filenamehash'");
								return $newcachefile;
							}
						} else {
							// cache file does not exists, make new one
							//WH_HTML::writeError("Kan cache file $cache->cachefile niet verwijderen");
							//$db->update_sql("DELETE FROM cache WHERE filenamehash = '$filenamehash'");							
						}
					}					
				}
				
				// data is not yet cached
				//echo "new";
				$newcachefile = WH_Cache::makeCacheFileName($filenamehash, $timehash, $extension, $folder);
				WH_Cache::saveFilesToCache($data, $newcachefile);
				$db->insert_array("cache", Array("filenamehash"=>$filenamehash,"timehash"=>$timehash, "cachefile"=>$newcachefile), true);
				return $newcachefile;
				break;
			case "html":
				$htmlcache = $folder.'page'.$data.".".$extension;
				if (file_exists($htmlcache)) {
					return file_get_contents($htmlcache);
				} else {
					return false;
				}
				break;
			default:
				return false;
				break;		
		}
		return false;
	}
	
	function savePageToCache($data, $pageid) {
		global $cf;
		$htmlcache = 'cache/page'.$pageid.".html";
		$fh = fopen($htmlcache, 'w') or WH_HTML::writeError("Kan cache file $htmlcache niet openen, probeer a.u.b. opnieuw.");
		fwrite($fh, $data);
		fclose($fh);
		return true;
	}
	
	function resetPageCache($pageid = "*") {
		global $cf;
		if ($pageid == "*") {
			$cachefiles = scandir('cache/');
			foreach ($cachefiles as $file) {
				if (strpos($file,".")!==false && substr($file,-4) == "html") {
					if (!unlink("cache/".$file)) {
						return false;
					}
				}
			}
			return true;
		} else {
			$htmlcache = 'cache/page'.$pageid.".html";
			if (file_exists($htmlcache)) {
				return unlink($htmlcache);
			} else {
				return false;
			}
		}
	}
	
	function saveFilesToCache($data, $filename) {
		global $cf;
		$output = "";
		foreach ($data as $item) {
			if (file_exists($item)) {
				$output .= file_get_contents($item)."\n\r";
			}
		}
		// detect file type for compression
		if (substr(strtolower($filename),-3)=="css" && !$cf->whDebug) {
			$output = WH_Cache::remove_css_comments($output);	
		} elseif (substr(strtolower($filename),-2)=="js" && !$cf->whDebug) {
			$output = WH_Cache::remove_js_comments($output);
		}
		
		$fh = fopen($filename, 'w') or WH_HTML::writeError("Kan cache file $filename niet openen, probeer a.u.b. opnieuw.");
			fwrite($fh, $output);
		fclose($fh);
		return true;
	}
	
	function makeCacheFileName($filenamehash, $timehash, $extension, $folder = NULL) {
		if ($folder) {
			return $folder.$filenamehash.".".$timehash.".".$extension;
		} else {
			return "cache/".$filenamehash.".".$timehash.".".$extension;
		}
	}
	
	/**
	 * function to read cache entries in database
	 * 
	 * @return object
	 */
	function readCacheEntries() {
		global $db;
		$sql = "SELECT * FROM cache";
		$db->select($sql);
		return $db->get_obj();
	}
	
	/**
	 * JSmart Compressor v1.0 function
	 *
	 * @copyright farhadi.ir
	 * @param string $str
	 * @return string
	 */
		
	function remove_css_comments($str) {
		$res = '';
		$i=0;
		$inside_block = false;
		while ($i+1<strlen($str)) {
			if ($str{$i}=='"' || $str{$i}=="'") {//quoted string detected
				$quote = $str{$i};
				do {
					if ($str{$i} == '\\') {
						$res .= $str{$i++};
					}
					$res .= $str{$i++};
				} while ($i<strlen($str) && $str{$i}!=$quote);
				$res .= $str{$i++};
				continue;
			} elseif (strtolower(substr($res, -4))=='url(') {//uri detected
				do {
					if ($str{$i} == '\\') {
						$res .= $str{$i++};
					}
					$res .= $str{$i++};
				} while ($i<strlen($str) && $str{$i}!=')');
				$res .= $str{$i++};
				continue;
			} elseif ($str{$i}.$str{$i+1}=='/*') {//css comment detected
				$i+=3;
				while ($i<strlen($str) && $str{$i-1}.$str{$i}!='*/') $i++;
				if ($current_char == "\n") $str{$i} = "\n";
				else $str{$i} = ' ';
			}
			
			if (strlen($str) <= $i+1) break;
			
			$current_char = $str{$i};
			
			if ($inside_block && $current_char == '}') {
				$inside_block = false;
			}
			
			if ($current_char == '{') {
				$inside_block = true;
			}
			
			if (preg_match('/[\n\r\t ]/', $current_char)) $current_char = " ";
			
			if ($current_char == " ") {
				$pattern = $inside_block?'/^[^{};,:\n\r\t ]{2}$/':'/^[^{};,>+\n\r\t ]{2}$/';
				if (strlen($res) &&	preg_match($pattern, $res{strlen($res)-1}.$str{$i+1}))
					$res .= $current_char;
			} else $res .= $current_char;
			
			$i++;
		}
		if ($i<strlen($str) && preg_match('/[^\n\r\t ]/', $str{$i})) $res .= $str{$i};
		return $res;
	}
	
	/**
	 * JSmart Compressor v1.0 function
	 *
	 * @copyright farhadi.ir
	 * @param string $str
	 * @return string
	 */
	
	function remove_js_comments($str) {
		$res = '';
		$maybe_regex = true;
		$i=0;
		$current_char = '';
		while ($i+1<strlen($str)) {
			if ($maybe_regex && $str{$i}=='/' && $str{$i+1}!='/' && $str{$i+1}!='*') {//regex detected
				if (strlen($res) && $res{strlen($res)-1} === '/') $res .= ' ';
				do {
					if ($str{$i} == '\\') {
						$res .= $str{$i++};
					} elseif ($str{$i} == '[') {
						do {
							if ($str{$i} == '\\') {
								$res .= $str{$i++};
							}
							$res .= $str{$i++};
						} while ($i<strlen($str) && $str{$i}!=']');
					}
					$res .= $str{$i++};
				} while ($i<strlen($str) && $str{$i}!='/');
				$res .= $str{$i++};
				$maybe_regex = false;
				continue;
			} elseif ($str{$i}=='"' || $str{$i}=="'") {//quoted string detected
				$quote = $str{$i};
				do {
					if ($str{$i} == '\\') {
						$res .= $str{$i++};
					}
					$res .= $str{$i++};
				} while ($i<strlen($str) && $str{$i}!=$quote);
				$res .= $str{$i++};
				continue;
			} elseif ($str{$i}.$str{$i+1}=='/*') {//multi-line comment detected
				$i+=3;
				while ($i<strlen($str) && $str{$i-1}.$str{$i}!='*/') $i++;
				if ($current_char == "\n") $str{$i} = "\n";
				else $str{$i} = ' ';
			} elseif ($str{$i}.$str{$i+1}=='//') {//single-line comment detected
				$i+=2;
				while ($i<strlen($str) && $str{$i}!="\n") $i++;
			}
			
			$LF_needed = false;
			if (preg_match('/[\n\r\t ]/', $str{$i})) {
				if (strlen($res) && preg_match('/[\n ]/', $res{strlen($res)-1})) {
					if ($res{strlen($res)-1} == "\n") $LF_needed = true;
					$res = substr($res, 0, -1);
				}
				while ($i+1<strlen($str) && preg_match('/[\n\r\t ]/', $str{$i+1})) {
					if (!$LF_needed && preg_match('/[\n\r]/', $str{$i})) $LF_needed = true;
					$i++;
				}
			}
			
			if (strlen($str) <= $i+1) break;
			
			$current_char = $str{$i};
			
			if ($LF_needed) $current_char = "\n";
			elseif ($current_char == "\t") $current_char = " ";
			elseif ($current_char == "\r") $current_char = "\n";
			
			// detect unnecessary white spaces
			if ($current_char == " ") {
				if (strlen($res) &&
					(
					preg_match('/^[^(){}[\]=+\-*\/%&|!><?:~^,;"\']{2}$/', $res{strlen($res)-1}.$str{$i+1}) ||
					preg_match('/^(\+\+)|(--)$/', $res{strlen($res)-1}.$str{$i+1}) // for example i+ ++j;
					)) $res .= $current_char;
			} elseif ($current_char == "\n") {
				if (strlen($res) &&
					(
					preg_match('/^[^({[=+\-*%&|!><?:~^,;\/][^)}\]=+\-*%&|><?:,;\/]$/', $res{strlen($res)-1}.$str{$i+1}) ||
					(strlen($res)>1 && preg_match('/^(\+\+)|(--)$/', $res{strlen($res)-2}.$res{strlen($res)-1})) ||
					preg_match('/^(\+\+)|(--)$/', $current_char.$str{$i+1}) ||
					preg_match('/^(\+\+)|(--)$/', $res{strlen($res)-1}.$str{$i+1})// || // for example i+ ++j;
					)) $res .= $current_char;
			} else $res .= $current_char;
			
			// if the next charachter be a slash, detects if it is a divide operator or start of a regex
			if (preg_match('/[({[=+\-*\/%&|!><?:~^,;]/', $current_char)) $maybe_regex = true;
			elseif (!preg_match('/[\n ]/', $current_char)) $maybe_regex = false;
			
			$i++;
		}
		if ($i<strlen($str) && preg_match('/[^\n\r\t ]/', $str{$i})) $res .= $str{$i};
		return $res;
	}
	
	function makeHTMLCacheId($id, $lang, $style) {
		return "_".$id."_".$lang."_".$style;
	}
		
} ?>