<?php
/**
 * Cambio v0.5a
 * 
 * http://cambiocms.org/
 * @package Cambio
 */
if (defined("CAMBIO") or die("Access error"));

/**
//     TYPE 	BYTE 	 MINIMUM VALUE	MAXIMUM VALUE
//TINYINT 	 1 Byte 	-128 	127 
//BIT 	(M+7)/8 Byte 	 -	-
//SMALLINT 	2 Byte 	-32768	32767
//MEDIUMINT 	3 Byte 	-8388608	8388607
//INT(M) (UNSIGNED) (ZEROFILL)	4 Byte 	-2147483648	2147483647
//INTERGER [M]	4 Byte 	-	-
//BIGINT [M]	8 Byte 	-9223372036854775808	9223372036854775807
//FLOAT [precision]	4 Byte		
//FLOAT [(M, D)]	8 Byte		
//DOUBLE [(M,D)]	8 Byte		
//DOUBLE precision [(M, D)]	8 Byte 	-1.7976931348623157E+308 to-2.2250738585072014E-308, 0,	2.2250738585072014E-308 to 1.7976931348623157E+308
//REAL [(M, D)]	8 Byte 		
//DECIMAL [(M ,D)]	M+2 Byte 	-999.99	999.99
//NUMERIC[(M,D)] 	M+2 Byte 	
	
//VARCHAR 	L+1 Byte 	0	255
//CHAR	M Byte 	0	255
//TINYBLOB	L+1 Byte 	0	256
//TINYTEXT	L+1 Byte 	0	255  (2^8-1) Char 
//BLOB OR TEXT	L+2 Byte 	 0	 65,535 (2^16-1)char  
//MEDIUMBLOB  	L+3 Byte 	-	16,777,215(2^24-1)char
//MEDIUMTEXT	L+3 Byte 	-	16,777,215(2^24-1)char
//LONGBLOB	L+4 Byte  	-	4,294,967,295(2^32-1)char
//LONGTEXT 	L+4 Byte  	-	4,294,967,295 or 4GB

//ENUM ('value1, value2',..)	1 or  2 Byte 	0 	65,535
//SET ('value1,' value 2,' .....)	1 to 8 Byte 	0	64
//
//
//MySQL Store the Date and Time Type                           Column Type 	                                Store Data
//DATE	3 Byte
//DATETIME 	8 Byte
//TIMESTAMP 	4 Byte
//TIME 	3 Byte
//YEAR 	1 Byte**/

class WH_DBEditor {
	
	var $_dbtypes = Array(
		"numeric" => "int bit float double real decimal numeric",
		"string" => "char blob text",
		"date" => "date time year",
		"enum", "enum set"
	);
	
	/* @var $fields WH_DBE_Field */
	var $fields = Array();
	
	const MODE_LIST = 0;
	const MODE_EDIT = 1;
	const MODE_ADD = 2;
	
	
	/**
	 * Database editor class for WH website
	 *
	 * @return WH_DBEditor
	 */
	function WH_DBEditor() {
		// initialize		
	}
	
	function init() {
		return true;
	}
	
	/**
	 * Mode can be:
	 * 0 = List
	 * 1 = Edit
	 * 2 = Add 
	 *
	 * @param string $tablename
	 * @param int $mode
	 * @param array $options
	 * @param string $where
	 * @param int $modid
	 * @param string $task
	 * @return string
	 */
	function detail($tablename, $mode, $options, $where = null, $return_modid, $save_task = "save", $return_task = 'display', $return_filter = null, $return_extraparams = null) {
		global $cf;
		
		switch ($mode) {
			case 0:
				// LIST
				$tmpl = "view";				
			case 1:
				// EDIT
				if (!$tmpl) { $tmpl = "edit"; }
				// get data first and return error if record not found
				global $db;
				$db->select("SELECT * FROM $tablename WHERE $where");
				$data = $db->get_array();
				if (empty($data) || count($data) > 1) {
					return "No or multiple records found, please check your SQL query (the WHERE part: $where) ".WH_HTML::adminLink($return_modid, $return_task, null, "Terug", false, null, "filter=".$data[$return_filter]."&".$return_extraparams);
				} else {
					$data = $data[0];
				}
				break;
			case 2:
				// ADD
				$tmpl = "edit";
		}
		
		$ret = "";
		
		if ($mode > 0) {
			// begin form
			$ret .= WH_HTML::beginform($return_modid, $save_task, null, "filter=".$data[$return_filter]."&".$return_extraparams);			
		}
		
		if ($mode == 1) {
			// where condition
			//$ret .= "<input type=\"hidden\" name=\"dbe_where\" value=\"$where\" />";
		}
		
		// title
		if ($options["title"]) {
			$ret .= "<h2>{$options["title"]}</h2>";
		} else {
			$ret .= "<h2>$tmpl record from table $tablename</h2>";
		}
		
		// get table columns
		$tablecolumns = $this->_readtable($tablename);

		$ret .= "<dl>";
		foreach ($tablecolumns as $column) {
			
			// hide column?
			if ($options["columns"][$column->Field]["show"] == true or !isset($options["columns"][$column->Field]["show"])) {
				
				// field name
				$fieldname = $column->Field;
				
				// get field type and max len
				$tmp = explode("(", $column->Type);
				$dbtype = $tmp[0];
				$fieldmaxlen = str_replace(")","",$tmp[1]);
				$fieldtype = $this->_findfieldtype($dbtype);

				// override field type?
				if (isset($options["columns"][$fieldname]["type"])) {
					$fieldtype = $options["columns"][$fieldname]["type"];
				}
				
				// override field title?
				if (isset($options["columns"][$fieldname]["title"])) {
					$fieldtitle = $options["columns"][$fieldname]["title"];
				} else {
					$fieldtitle = $fieldname;
				}
				
				// field data
				$fielddata = $data[$fieldname];
				
				// override field required?
				$fieldrequired = false;
				if (isset($options["columns"][$fieldname]["required"])) {
					$fieldrequired = $options["columns"][$fieldname]["required"];
				} else {
					if ($column->Null == "NO") {
						$fieldrequired = true;
					}
				}
				if ($fieldrequired) {
					$fieldrequired = " <span style=\"color: red;\">*</span>";
				}
				
				// field hidden
				$fieldhidden = false;
				if (isset($options["columns"][$fieldname]["hidden"])) {
					$fieldhidden = $options["columns"][$fieldname]["hidden"];
				} else {
					if ($column->Extra == "auto_increment" || $column->Key == "PRI") {
						$fieldhidden = true;
					}
				}
				if ($fieldhidden) {
					$fieldtype = "hidden";
				}
				
				// parent data
				$fieldparent = array();
				if (isset($options["columns"][$fieldname]["parent"]) && $fieldtype == "linked") {
					$fieldparent = $options["columns"][$fieldname]["parent"];
					$fieldparent["selected"] = $fielddata;
				}
				
				// list data
				$fieldlist = array();
				if (isset($options["columns"][$fieldname]["list"]) && $fieldtype == "list") {
					$fieldlist = $options["columns"][$fieldname]["list"];
				}
								
				// include field object
				$fieldclassname = "WH_DBE_Field_".$fieldtype;
				if (!class_exists($fieldclassname)) {
					$fieldtypefile = $cf->whDir."modules".$cf->whDS."dynamic".$cf->whDS."fields".$cf->whDS.strtolower($fieldtype).".class.php";
					if (file_exists($fieldtypefile)) {
						include($fieldtypefile);
					} else {
						WH_HTML::writeError("Field type file ($fieldtypefile) not found.", true);
					}
				}
				
				// create field object								
				/* @var $tmpfield WH_DBE_Field */
				$tmpfield = new $fieldclassname;
				
				// set field vars
				$tmpfield->type = $fieldtype;
				$tmpfield->maxlen = $fieldmaxlen;
				$tmpfield->title = $fieldtitle;
				$tmpfield->name = $fieldname;
				$tmpfield->value = $fielddata;
				$tmpfield->required = $fieldrequired;
				$tmpfield->parent = $fieldparent;
				$tmpfield->list = $fieldlist;
				
				$this->fields[$fieldname] = $tmpfield;
				
				// process it!
				$ret .= $this->fields[$fieldname]->process($tmpl);		
				// render it!
				$ret .= $this->fields[$fieldname]->getHTML($tmpl);				
			}
		}
		$ret .= "</dl>";
		
		if ($mode > 0) {
			// submit button
			if (isset($options["submitbutton"])) {
				$submittext = $options["submitbutton"];
			} else {
				$submittext = WH_Lang::_("WHADMIN_SAVE",false,'static');
			}
			$ret .= WH_HTML::endform($submittext, true, true);			
		}
		
		// return button
		$ret .= ' '.WH_HTML::adminLink($return_modid, $return_task, null, WH_Lang::_("WHADMIN_BACK",false,"static"), false, null, "filter=".$data[$return_filter]."&".$return_extraparams);
		
		if ($mode > 0) {
			// close form
			$ret .= "</form>";
		}
		
		return $ret;
	}
			
	function delete($tablename, $where) {
		global $db;
		$saved = $db->update_sql("DELETE FROM $tablename WHERE $where");
		if (!$saved) {
			WH_HTML::adminWarning(WH_Lang::_("WHADMIN_DELETEFAILED", false, "modules/dynamic"));
		} else {
			WH_HTML::adminMsg(WH_Lang::_("WHADMIN_DELETESUCCESS", false, "modules/dynamic"));
		}
		return $saved;
	}
	
	function updateTable($tablename, $data, $where) {
		global $db;
		$saved = $db->update_array($tablename, $data, $where);
		if (!$saved) {
			WH_HTML::adminWarning(WH_Lang::_("WHADMIN_SAVEFAILED", false, "modules/dynamic"));
		} else {
			WH_HTML::adminMsg(WH_Lang::_("WHADMIN_SAVESUCCESS", false, "modules/dynamic"));
		}
		return $saved;
	}
	
	function addToTable($tablename, $data) {
		global $db;
		$saved =  $db->insert_array($tablename, $data);
		if (!$saved) {
			WH_HTML::adminWarning(WH_Lang::_("WHADMIN_INSERTFAILED", false, "modules/dynamic"));
		} else {
			WH_HTML::adminMsg(WH_Lang::_("WHADMIN_INSERTSUCCESS", false, "modules/dynamic"));
		}
		return $saved;
	}
	
	function hasChildren($table, $id) {
		switch ($table) {
			case "section":
				$sql = "SELECT COUNT(*) FROM mod_dyn_type WHERE dynid = ".(int) $id;
				break;
			case "type":
				$sql = "SELECT COUNT(*) FROM mod_dyn_field WHERE typeid = ".(int) $id;
				break;
			default:
				$url = "";
		}
		global $db;
		return (int) $db->select_one($sql);
	}
	
	function _findfieldtype($dbtype) {
		foreach ($this->_dbtypes as $type => $values) {
			$valuesarray = explode(" ", $values);
			foreach ($valuesarray as $value) {
				if (substr_count($dbtype, $value) > 0) {
					return $type;
				}
			}
		}
	}
	
	function _readtable($tablename) {
		global $db;
		$db->select("DESCRIBE $tablename");
		return $db->get_obj();
	}	
	
}