<?php
/**
 * Cambio v0.5a
 * 
 * http://cambiocms.org/
 * @package Cambio
 */
if (defined("CAMBIO") or die("Access error"));

class WH_Document extends WH_Page {
	
	var $htmltitel;
	var $task;
	
	var $uid = null;
	var $tid = null;
	var $isa = null;
	
	var $modules;	
	var $stylesheets = Array();
	var $javascript = Array();
	var $meta;
	var $links;
	var $onload;
	var $isadmin = false;
	var $lang;
	var $style;
	
	var $warnings = array();
	var $messages = array();
	
	var $nocache = false;
	var $layoutitems = Array();
		
	var $_get;
	var $_post;
	var $_session;
	var $_cookie;
	
	/**
	 * Document class for WH website
	 *
	 * @var integer $id
	 * @return WH_Document
	 */
	function WH_Document($id) {
		if (!is_null($id)) {
			// initialize
			global $wh, $db;
			// set page properties
			parent::setProperties($id);
			// get modules for this page
			$this->modules = $wh->modules->getPageModules($id);
			// get layout items for document
			$this->layoutitems = $wh->layouts->{$this->layout}->items;			
		}
	}
	
	function checkLogin($uid, $checkforadminrights = false) {
		global $db;
		
		$dirhash_session = WH_Helper::get('dir_hash','session');
		$uidhash_session = WH_Helper::get('uid_hash','session');
		
		$db->select("SELECT user, pass, isadmin FROM users, usertypes WHERE users.usertype_id = usertypes.id AND users.id = $uid");
		$res = $db->get_row();
		$uidhash_check = md5(strtolower($res["user"]).$res["pass"]);
		$dirhash_check = md5($_SERVER["SCRIPT_FILENAME"]);
		
		if ($uidhash_check == $uidhash_session && $dirhash_check == $dirhash_session) {
			if ($checkforadminrights) {
				if ($res["isadmin"] == 1) {
					return true;
				} else {
					return false;
				}
			} else {
				return true;
			}
		} else {
			return false;
		}
	}
	
	function setLang($setcd = true) {
		global $cf;
		/*
		 * TODO: relate TLD to languages to auto-detect language based on hostname visitor
		 *
		$visitorip = $_SERVER['REMOTE_ADDR'];
		$ip = gethostbyname ($visitorip);
		$host = gethostbyaddr($ip);
		$domain = explode(".",$host);

		$tld = $domain[count($domain)-1];
		echo $tld;
		*/
			
		// change language?
		$lang = WH_Helper::get('lang');
		if (isset($lang)) {
			WH_Helper::set('lang', $lang, "cookie");
		} else {
			// try to get from cookie
			$lang = WH_Helper::get('lang','cookie');
			// try to detect from ip
			if (!$lang && $cf->whLanguageAutoDetect) {
				// surpress warning when no internet connection is available
				$old_reporting = error_reporting(0);
				$geolang = file_get_contents($cf->whGeoIpServer."/?ip=".$_SERVER['REMOTE_ADDR']);
				error_reporting($old_reporting);
				if (WH_Document::isLangAvailable($geolang)) {
					$lang = $geolang;
				}
			}
			// use default
			if (!$lang) {
				$lang = WH_Document::getDefaultLang();
			}
		}
		if ($setcd) {
			$this->lang = strtolower($lang);
		} else {
			return strtolower($lang);
		}
				
	}
	
	function setStyle($setcd = true) {
		global $cf;
		
		// change language?
		$style = WH_Helper::get('style');
		if (isset($style)) {
			WH_Helper::set('style', $style, "cookie");
		} else {
			// try to get from cookie
			$style = WH_Helper::get('style','cookie');			
			// use default
			if (!$style) {
				$style = null;
			}
		}
		if ($setcd) {
			$this->style = strtolower($style);
		} else {
			return strtolower($style);
		}
				
	}
	
	function getDefaultLang() {
		global $cf;
		
		$langs = explode(",",$cf->whLang);
		
		// return default language
		return trim($langs[0]);
	}
	
	function isLangAvailable($lang) {
		global $cf;
		
		$lang = strtolower($lang);
		$langs = explode(",",strtolower($cf->whLang));
		
		if (in_array($lang, $langs)) {
			return true;
		} else {
			return false;
		}		
	}
	
	function addCSS($css) {
		$this->stylesheets[] = $css;
	}
	
	function addJS($js) {
		$this->javascript[] = $js;
	}
	
	function addJQuery() {
		$jqueryjs = "modules/admin/tmpl/js/jquery.js";
		if (!in_array($jqueryjs, $this->javascript)) {
			$this->javascript[] = $jqueryjs;
		}		
	}
	
}