<?php
/**
 * Cambio v0.5a
 * 
 * http://cambiocms.org/
 * @package Cambio
 */
if (defined("CAMBIO") or die("Access error"));

class WH_Layouts {
		
	/**
	 * Layouts class for WH website
	 *
	 * @return WH_Layouts
	 */
	function WH_Layouts($id = NULL) {
		return $this->_init($id);
	}
	
	function _init($id = NULL) {
		// initialize
		global $db;
		$db->select("SELECT * FROM layout ORDER BY name ASC");
		$layouts = $db->get_obj();
		$db->select("SELECT * FROM layout_items");
		$items = $db->get_obj();
		foreach ($layouts as $layout) {
			$this->{$layout->id} = $layout;
			$this->{$layout->id}->items = (object) Array();
			foreach ($items as $item) {
				if ($item->layout == $layout->id) {
					$this->{$layout->id}->items->{$item->id} = $item;
				}
			}
		}
		// return pages
		return $this->getLayouts($id);
	}
	
	/**
	 * Get instance creating one if necessary
	 *
	 * @param integer $id
	 * @return WH_Pages
	 */
	function getInstance($id = NULL) {
		static $instance;
		if (!isset($instance)) {
			$instance = new WH_Layouts();
		}
		if (!is_null($id)) {
			return $instance->getLayouts($id);
		} else {
			return $instance;
		}
	}
	
	function getLayouts($id = NULL) {
		if (!is_null($id)) {
			if ($this->$id) {
				return $this->$id;
			} else {
				return false;
			}
		} else {
			return $this;	
		}
	}
	
	function addLayout($id, $name, $tmpl, $styles = null) {
		$this->$id->id = $id;
		$this->$id->name = $name;
		$this->$id->tmpl = $tmpl;
		$this->$id->styles = $styles;
	}
	
	function addLayoutItem($id, $layout, $type, $module, $pos, $replaceable) {
		$this->$layout->items->$id->id = $id;
		$this->$layout->items->$id->type = $type;
		$this->$layout->items->$id->module = $module;
		$this->$layout->items->$id->pos = $pos;
		$this->$layout->items->$id->replaceable = $replaceable;
	}
	
	function getLayoutItem($itemid) {
		foreach ($this as $layout) {
			foreach ($layout->items as $item) {
				if ($item->id == $itemid) {
					return $layout->items->$itemid;
				}
			}
		}
	}
	
	function getLayoutIdOfItem($itemid) {
		foreach ($this as $layout) {
			foreach ($layout->items as $item) {
				if ($item->id == $itemid) {
					return $layout->id;
				}
			}
		}
	}
		
} ?>