<?php
/**
 * Cambio v0.5a
 * 
 * http://cambiocms.org/
 * @package Cambio
 */
if (defined("CAMBIO") or die("Access error"));

class WH_Lang {
	
	/**
	 * Language class for WH website
	 *
	 * @return WH_Lang
	 */
	function WH_Lang() {
		// initialize
	}
	
	function text2ini($value) {
		$prep = str_replace("=", "~@~", $value);
		return $prep;
	}
	
	function ini2text($value) {
		$prep = str_replace("~@~", "=", $value);
		return $prep;
	}
	
	function writeIni($name, $lang, $value, $dir) {
		global $cf, $cd;
				
		$rel = "";
		if ($cd->isadmin) {
			$rel = "..".$cf->whDS;
		}
		
		$ini = null;
		
		// get ini file
		$inifile = $rel . WH_Lang::getIniFile($dir, $lang);
		
		if (file_exists($inifile)) {
			$file = file($inifile, FILE_IGNORE_NEW_LINES);
			$changed = false;
			foreach ($file as $entry) {
				$entry = explode("=",$entry);
				
				// trim linefeeds etc
				$entry[0] = trim($entry[0]);
				$entry[1] = trim($entry[1]);
				
				// is there a =?
				if (count($entry)>1) {
					if ($entry[0] == $name) {
						// override old value
						$regel = WH_Lang::text2ini($name) . "=" . WH_Lang::text2ini($value);
						$changed = true;
					} else {
						// copy old values
						$regel = $entry[0] . "=" . $entry[1];
					}
				}
				
				// add to ini file
				if ($regel!="" && $regel!="=") {
					$ini .= $regel . "\n";
				}
			}
			
			// add value of not already done so
			if ($changed == false) {
				$ini .= WH_Lang::text2ini($name) . "=" . WH_Lang::text2ini($value);
			}
		} else {
			// geen bestand, maakt automatisch aan
			$ini = WH_Lang::text2ini($name) . "=" . WH_Lang::text2ini($value);
		}
				
		$fh = fopen($inifile, 'w') or WH_HTML::writeError("Kan INI file $inifile niet openen, probeer a.u.b. opnieuw.");
		fwrite($fh, $ini);
		fclose($fh);
	}
	
	function readIni($dir, $lang, $name = null) {
		global $cf, $cd;
			
		$langs = null;
		$ids = null;
		
		$rel = "";
		if ($cd->isadmin) {
			$rel = "..".$cf->whDS;
		}
		
		// get ini file
		$inifile = $rel . WH_Lang::getIniFile($dir, $lang);		

		if (file_exists($inifile)) {
			$file = file($inifile, FILE_IGNORE_NEW_LINES);
			// write admin warning with large files
			if ($cd->isa && count($file) > 500) {
				WH_HTML::adminWarning("INI file $inifile exceeds 500 lines. Try to remove unused entries from this file to improve site performance.");
			}
			foreach ($file as $entry) {
				$entry = explode("=",$entry);
				$langs[trim(WH_Lang::ini2text($entry[0]))] = trim((WH_Lang::ini2text($entry[1])));
			}
			return $langs;
		} else {
			// geen bestand
			return false;
		}
	}
	
	function getIniFile($dir, $lang) {
		global $cf;
		
		// add slashes and dots
		switch ($dir) {
			case 'pages':
			case 'static':
			case 'install':
				$dir .= $cf->whDS;
				break;
			case 'modules':
				$dir .= $cf->whDS . 'modules.';
				break;
			case 'pos':
				$dir = 'pages'.$cf->whDS.'pos.';
				break;
			default:
				if (substr($dir,-8)=="/content") {
					$dir .= ".";
				} elseif (substr($dir,0,8)=="modules/") {
					$dir .= $cf->whDS;
				} elseif (substr($dir,0,8)=="plugins/") {
					$dir .= $cf->whDS;
				} else {
				}
				break;
		}
		$dir .= $lang . '.ini';
		// add rel path
		return 'languages/' . $dir;
	}
	
	function _($name, $edit = true, $dir = null, $return_null = false) { 
		global $cd, $cf;
						
		// define static vars
		static $langs, $ids;
				
		// autoretrieve current calling classname to set dir
		if (is_null($dir)) {
			$origin = debug_backtrace();
			// difference between php 4 and 5!!
			// PHP 5 METHOD:
			/* $origin = get_class($origin[0]["object"]);
			/
			/ / auto detect module origin
			if (strpos(strtolower($origin), "wh_module")!==false) {
				$dir = "modules/".str_replace("wh_module","",strtolower($origin));
			}
			// auto detect plugin origin
			if (strpos(strtolower($origin), "wh_plugin")!==false) {
				$dir = "plugins/".str_replace("wh_plugin","",strtolower($origin));
			}*/
			// PHP 4 METHOD:
			// use regexp of current file
			
			$origin = $origin[0]["file"];
			$ds = $cf->whDS;
			// direct template inclusion
			if (strpos($origin, $ds."modules".$ds) !== false) {
				$ds = ($ds=="/") ? "/\\/modules\\/[^\\/]*\//" : "/\\\\modules\\\\[^\\\\]*\\\\/";
				preg_match($ds, $origin, $origin);
				$origin = $origin[0];
				if (strpos(strtolower($origin), $cf->whDS."modules".$cf->whDS)!==false) {
					$origin = str_replace($cf->whDS.'modules'.$cf->whDS,"",strtolower($origin));
					$origin = substr($origin, 0, -1);
					$dir = 'modules/'.$origin;
				}			
			} elseif (strpos($origin, ".parser.inc") !== false) {
				// indirect (parser) template inclusion
				// last directory seperator
				$lastdirpos = strrpos($origin, $ds);
				$filename = substr($origin, $lastdirpos+1);
				$filename = str_replace(".parser.inc", "", $filename);
				$dir = 'modules/'.$filename;
			}
		}
		
		// add WH_ and WHADMIN_
		if (substr($name, 0 ,5) != "WHTIP" && 
			substr($name, 0, 8) != "WHADMIN_" && 
			substr($name, 0, 8) != "WHLANG_" && 
			substr($name, 0, 7) != "WHLANG_" && 
			substr($name, 0, 6) != "WHPOS_" && 
			substr($name, 0, 6) != "WHCAT_" && 
			substr($name, 0, 9) != "WHMODULE_" && 
			substr($name, 0, 3) != "WH_" &&
			substr($dir, 0, 8) == "modules/" &&
			strpos($dir, "content") === false) {
				
			if ($cd->isadmin) {
				$name = "WHADMIN_".$name;
			} else {
				$name = "WH_".$name;
			}
		}
				
		if (is_null($dir)) {
			$dir = "static";
		}
		// retrieve ini values when not already done
		if (!isset($langs[$dir])) {
			$ini = WH_Lang::readIni($dir, $cd->lang);
			$langs[$dir] = $ini;
		}
		
		// get translated string
		$lang = $langs[$dir][$name];
		
		// make edit button, but not in admin mode
		if ($cd->isa && $cd->isadmin == false && $edit == true) {
			// also make a lang elements editable > edit button
			// TODO > hardcode id of lang module
			$edit1 = WH_HTML::editDiv(3, "edit", $dir."~@~".$name, false, WH_Lang::_('WHTIPHEADER_STATIC',false,'static'), WH_Lang::_('WHTIPBODY_STATIC', false, 'static'));
			$edit2 = "</div>";
		}
			
		if (!empty($langs[$dir][$name])) {
			$ret = $edit1.WH_HTML::clean($lang).$edit2;
		} else {
			if ($return_null) {
				return null;
			} else {
				// insert ini value
				if (!isset($langs[$dir][$name])) {
					WH_Lang::writeIni($name, $cd->lang, '', $dir);
				}
				// return
				$name = str_replace("WHADMIN_", "", $name);
				$name = str_replace("WH_", "", $name);
				$ret = $edit1.WH_HTML::clean($name).$edit2;

			}
		}
		return $ret;
	}
	
	function langFlag($langcode, $title = null) {
		global $cf;
		return "<img src=\"$cf->whGeoIpServer/flags/$langcode.png\" width=\"16\" height=\"11\" border=\"0\" alt=\"Flag: $langcode\" title=\"$title\" />";
	}
	
	function editButton($name, $buttontext, $dir = "static",  $tooltip_header = null, $tooltip_body = null) {
		//return WH_HTML::editButton(WH_Modules::getAdminModuleId("lang"), "edit", $dir."~@~".$name, $buttontext, false, $tooltip_header, $tooltip_body);
		// TODO: hardcoded module id!!
		return WH_HTML::adminImageLink(3, "edit", $dir."~@~".$name, $buttontext, false, "flag");
	}	
	
}