<?php
/**
 * Cambio v0.5a
 * 
 * http://cambiocms.org/
 * @package Cambio
 */
if (defined("CAMBIO") or die("Access error"));

class WH_Modules {
	
	/**
	 * Modules class for WH website
	 *
	 * @param integer $id
	 * @return WH_Modules
	 */
	function WH_Modules($id = NULL) {
		return $this->_init($id);
	}
	
	/**
	 * Init
	 *
	 * @param integer $id
	 * @return WH_Modules
	 */
	function _init($id = NULL) {
		// initialize
		global $db;
		$db->select("SELECT * FROM module ORDER BY pagina, pos, ordering");
		$results = $db->get_obj();
		foreach ($results as $result) {
			$this->{$result->id} = new WH_Module($result);
		}
		// return pages
		return $this->getModules($id);
	}
	
	/**
	 * Get instance creating one if necessary
	 *
	 * @param integer $id
	 * @return WH_Modules
	 */
	function getInstance($id = NULL) {
		static $instance;
		if (!isset($instance)) {
			$instance = new WH_Modules();
		}
		if (!is_null($id)) {
			return $instance->getModules($id);
		} else {
			return $instance;
		}
	}
	
	/**
	 * Get module for certain id or all modules if no id is goven
	 *
	 * @param integer $id
	 * @return WH_Module
	 */
	function getModules($id = NULL) {
		if (!is_null($id)) {
			if ($this->$id) {
				return $this->$id;
			} else {
				return false;
			}
		} else {
			return $this;	
		}
	}
	
	/**
	 * Get modules for certain page
	 *
	 * @param integer $pageid
	 * @return array
	 */
	function getPageModules($pageid) {
		$result = Array();
		foreach ($this as $module) {
			if ($module->pagina == $pageid) {
				$result[] = $module;
			}
		}
		return $result;
	}
	
	function getAdminModuleId($modulename) {
		foreach ($this as $module) {
			if ($module->pos == "admin" && $module->module == $modulename) {
				return $module->id;
			}
		}
		return false;
	}

	function getModuleId($modulename) {
		foreach ($this as $module) {
			if ($module->module == $modulename) {
				return $module->id;
			}
		}
		return false;
	}
	
	function getModulesXML() {
		$xml = new WH_XML();
		$doc = $xml->createDocument();
		$res = null;
		if ($doc->loadXML("../tmpl/_default/modules.xml", false)) {
			$modules = $doc->documentElement->toArray();
			$modules = $modules["modules"];
			foreach ($modules as $module) {
				if ($module) {
					$module = $module["module"];
					//WH_HTML::dump($module);
					$res[$module[0]["dir"][0]]->name = WH_Lang::_('WHMODULE_'.$module[0]["dir"][0],false,'modules'); //$module[1]["name"][0];
					$res[$module[0]["dir"][0]]->visible = $module["attributes"]["visible"];
					$res[$module[0]["dir"][0]]->cat = $module["attributes"]["cat"];
				}
			}
		} else {
			return false;
		}
		//WH_HTML::dump($res);
		return $res;		
	}
	
	function getPosXML() {
		$xml = new WH_XML();
		$doc = $xml->createDocument();
		$res = null;
		if ($doc->loadXML("../tmpl/_default/pos.xml", false)) {
			$positions = $doc->documentElement->toArray();
			$positions = $positions["positions"];
			foreach ($positions as $pos) {
				if ($pos) {
					$pos = $pos["pos"];
					$res[$pos["attributes"]["name"]] = WH_Lang::_('WHPOS_'.$pos["attributes"]["name"], false, 'pos');
				}
			}
		} else {
			return false;
		}
		//WH_HTML::dump($res);
		return $res;		
	}
	
	function getDefaultPos() {
		$xml = new WH_XML();
		$doc = $xml->createDocument();
		$res = null;
		if ($doc->loadXML("../tmpl/_default/pos.xml", false)) {
			$positions = $doc->documentElement->toArray();
			$positions = $positions["positions"];
			foreach ($positions as $pos) {
				if ($pos) {
					$pos = $pos["pos"];
					if ($pos["attributes"]["default"] == "true") {
						return $pos["attributes"]["name"];
					}
				}
			}
			return false;
		} else {
			return false;
		}		
	}
		
}