<?php
/**
 * Cambio v0.5a
 * 
 * http://cambiocms.org/
 * @package Cambio
 */
if (defined("CAMBIO") or die("Access error"));

class WH_Module {
		
	var $id;
	var $pagina;
	var $module;
	var $pos;
	var $tmpl;
	var $buttons;
	
	// parameters
	var $titel;
	var $ordering;
	var $align;
	var $access;
	var $user_access;
	var $attr;
		
	/**
	 * Module class for WH website
	 *
	 * @return WH_Module
	 */
	function WH_Module($data) {
		$this->_init($data);
		$this->_initAttr();
		return true;
	}
	
	function _init($data) {
		// initialize
		// set values
		foreach ((array) $data as $k => $v) {						
			$this->$k = $v;
		}
		return true;
	}
	
	function _initAttr() {
		if (!($this->attr instanceof WH_Attr)) {
			$this->attr = new WH_Attr($this->attr);
		}
	}
	
	/**
	 * Get instance creating one if necessary
	 *
	 * @param integer $id
	 * @return WH_Module
	 */
	function getInstance($id) {
		//echo "GET $id";
		static $instances;
		if (!isset( $instances )) {
			$instances = Array();
		}
		
		if (empty($instances[$id])) {
			$instances[$id] = new WH_Module($id);
		}
		return $instances[$id];
	}
	
	/**
	 * Set properties according to data in WH_Modules
	 *
	 * @param integer $id
	 * @return bool
	 */
	function setProperties($id) {
		$data = WH_Modules::getInstance($id);
		$this->_init($data);
		return true;
	}
	
	/**
	 * Load the module
	 * 
	 */	
	function loadModule($rel = null, $admin = false) {
		if (isset($this->id)) {
			$className = $admin ? 'WH_AdminModule'.$this->module : 'WH_Module'.$this->module;
			if ($admin == true) {
				$admin = ".admin";
			} else {
				$admin = "";
			}
			if (!class_exists($className)) {
				$modfile = $rel.'modules/'.$this->module.'/'.$this->module.$admin.'.php';
				if (file_exists($modfile)) {
					include($modfile);
					return true;
				} else {
					writeError("Module {$this->module} does not exist");
					return false;
				}
			} else {
				// class exists, module already loaded
				return true;
			}
		} else {
			return false;
		}
	}
	
	/**
	 * Render the module, calling the specified template
	 *
	 * @param string $tmpl
	 * @return bool
	 */
	function render($tmpl = null) {
		global $cd;
		
		// render admin module?
		if ($cd->isadmin) {
			$admin = ".admin";
			$rel = "../";
		}
		// get tmpl
		if (is_null($tmpl)) {			
			if ($this->tmpl) {
				$tmpl = $this->tmpl;
			} elseif ($cd->task && (WH_Helper::get('module') == $this->id || $cd->isadmin)) {
				$tmpl = $cd->task;
			} else {
				$tmpl = 'default';
			}
		}
		// get subclass for dynamic
		$dynsubclass = "";
		if ($this->module == "dynamic" && $cd->isadmin) {
			$taskarray = explode("_", $cd->task);
			if (count($taskarray) > 1) {
				$tmpl = str_replace("$taskarray[0]_","",$tmpl);
			}
			$dynsubclass = $taskarray[0].".";
		}
		// render task?
		if (isset($this->id) || $admin == true) {			
			global $cd, $wh;
			if (!$cd->isadmin) {
				$tmpltmpl = $rel.'tmpl/'.$wh->layouts->{$cd->layout}->tmpl.'/modules/'.$this->module.'/'.$dynsubclass.$tmpl.$admin.'.php';
			}
			$deftmpl = $rel.'modules/'.$this->module.'/tmpl/'.$dynsubclass.$tmpl.$admin.'.php';
			if (file_exists($tmpltmpl)) {
				$this->parseTmpl($tmpltmpl);
				//include($tmpltmpl);
			} else {
				$this->parseTmpl($deftmpl);
				//include($deftmpl);
			}
			return true;
		} else {
			return false;
		}
	}
	
	/**
	 * Parse the template (and replace language strings)
	 *
	 * @param string $file
	 */
	function parseTmpl($file) {
		global $cd, $cf;
		$tmplcontents = file_get_contents($file);		
		// check for dynamic language constructs
		if (strpos($tmplcontents,"{{")!==false && strpos($tmplcontents,"}}")!==false) {
			$tmptmpldir = $cf->whDir."tmp".$cf->whDS.$this->module.".parser.inc";
			if ($cd->isadmin) {
				$edit = "false";
			} else {
				$edit = "true";
			}
			$tmplcontents = preg_replace('/{{(\w+)}}/e', "WH_Lang::_('\\1', ".$edit.", 'modules/".$this->module."' )", $tmplcontents);
			
			$fp = fopen($tmptmpldir, "w+");
			
			// TODO: prevent lock for now, as it crashes rendering on windows server
			//if (flock($fp, LOCK_EX)) { // do an exclusive lock
			    fwrite($fp, $tmplcontents);
			//} else {
			//    WH_HTML::adminWarning("Couldn't lock the file !");
			//}
	
			include($tmptmpldir);
						
			flock($fp, LOCK_UN); // release the lock			
			fclose($fp);			
			unlink($tmptmpldir); // deletes the file
			
			//eval($tmplcontents);
		} else {
			include($file);
		}
		
	}
	
	function hasLinks($id = NULL) {
		if (!isset($id)) {
			$id = $this->id;
		}
		if (isset($id)) {
			global $db;
			$ret1 = intval($db->select_one("SELECT COUNT(id) FROM layout_items WHERE module = '$id' AND type = 1"));
			$ret2 = intval($db->select_one("SELECT COUNT(id) FROM defmod WHERE module = $id"));
			$ret = $ret1 + $ret2;
			return $ret;
		} else {
			return false;
		}
	}
	
	/**
	 * Below are functions for module parameter handling
	 */	
	
	function getTitle($newtitle, $customtitle, $id) {
		global $wh;		
		// get old title
		$oldtitle = $wh->modules->$id->titel;
		// make current title
		$newtitle = substr($newtitle,0,30);
		// updated content
		if ($customtitle == $oldtitle) {
			return $newtitle;
		// updated custom title
		} elseif ($oldtitle == $newtitle && $customtitle && $customtitle != $oldtitle && $customtitle != $newtitle) {
			return $customtitle;
		// updated title and updated content
		} elseif ($oldtitle != $newtitle && $customtitle != $oldtitle) {
			return $customtitle;
		}
	}
	
	function saveParameters(&$postdata, $title = NULL, $id = NULL) {
		// extract parameters
		$data = $this->getParameterArray($postdata);
		$attr = $this->getAttrArray($postdata);
		// give priority to original stored module id
		if (isset($this->id)) {
			$id = $this->id;
		}
		if (!isset($title)) {
			$title = $this->module;
		}
		if (!isset($id)) {
			$id = (int) WH_Helper::get('module', 'post');
		}
		if (isset($id)) {
			// get new title
			$data["titel"] = $this->getTitle($title, $data["titel"], $id);
			// serialize attr array
			$data["attr"] = serialize($attr);
			// update db
			global $db;
			$db->update_array("module", $data, "id = $id");
			// update module class
			$this->_init($data);
			return true;
		} else {
			return false;
		}
	}
	
	/**
	 * Compatibility
	 */
	function setTitle($a = null, $b = null) {
		return true;
	}
	
	/**
	 * Gets parameter array and deletes from given input
	 *
	 * @param array $array
	 * @return array
	 */
	function getParameterArray(&$array) {
		$ret = $array["parameter"];
		unset($array["parameter"]);
		return $ret;
	}
	
	/**
	 * Gets attr array and deletes from given input
	 *
	 * @param array $array
	 * @return array
	 */
	function getAttrArray(&$array) {
		$ret = $array["attr"];
		unset($array["attr"]);
		return $ret;
	}
	
	/**
	 * Echoes Module parameter input admin screen for given parameters (in array $parameters)
	 *
	 * @param array $parameters
	 */
	function writeModuleProperties($parameters = null, $show = 0, $sidebar = true) {
		if (!$sidebar) {
			echo WH_HTML::adminPane("WHADMIN_GENERALPROPERTIES", $this->module, $show);
		} else {
			?>
			<div class="sidebar-title">
				<?php echo WH_Lang::_('WHADMIN_GENERALPROPERTIES', false, 'static'); ?>
			</div>
			<div class="sidebar-item">	
			<?php
		}
		echo "<dl>";
		if (!$parameters) {
			$parameters = array("align","page","pos","title");
		}
		foreach ($parameters as $parameter) {
			switch ($parameter) {
				case "access": ?>
					<dt><?php echo WH_Lang::_("WHADMIN_ACCESS", false, 'static'); ?>:</dt>
					<dd><select name="parameter[access]">
						<option value="0"<?php if ($this->access==0) { echo " selected";}?>><?php echo WH_Lang::_("WHADMIN_ACCESSPUBLIC", false, 'static'); ?></option>
						<?php global $db;
						$usertypes = $db->select("SELECT usertype FROM usertypes");
						echo "<option>hoi:".print_r($usertypes)."</option>";
						foreach ($usertypes as $usertype) {
							echo "<option>HOI</option>".$usertype->usertype;
						}
						?>
						<option value="1"<?php if ($this->access==1) { echo " selected";}?>><?php echo WH_Lang::_("WHADMIN_ACCESSFRONTENDUSERS", false, 'static'); ?></option>
						<option value="2"<?php if ($this->access==2) { echo " selected";}?>><?php echo WH_Lang::_("WHADMIN_ACCESSBACKENDUSERS", false, 'static'); ?></option>
						<option value="singleuser"<?php if ($this->access==3) { echo " selected";}?>><?php echo WH_Lang::_("WHADMIN_ACCESSUSER", false, 'static'); ?></option>
					</select></dd>
					<?php break;
				case "user_access": ?>
					<dt><?php echo WH_Lang::_("WHADMIN_USERACCESS", false, 'static'); ?>:</dt>
					<dd><select name="parameter[user_access]">
						<option value="">(<?php echo WH_Lang::_("WHADMIN_USERACCESSDEFAULT", false, 'static'); ?>)</option>
					</select></dd>
					<?php break;
				case "ordering":
					break;
				case "align": ?>
					<dt><?php echo WH_Lang::_("WHADMIN_ALIGN", false, 'static'); ?>:</dt>
					<dd><select name="parameter[align]">
						<option value="">(<?php echo WH_Lang::_("WHADMIN_ALIGNDEFAULT", false, 'static'); ?>)</option>
						<option value="left"<?php if ($this->align=="left") { echo " selected";}?>><?php echo WH_Lang::_("WHADMIN_ALIGNLEFT", false, 'static'); ?></option>
						<option value="right"<?php if ($this->align=="right") { echo " selected";}?>><?php echo WH_Lang::_("WHADMIN_ALIGNRIGHT", false, 'static'); ?></option>
						<option value="center"<?php if ($this->align=="center") { echo " selected";}?>><?php echo WH_Lang::_("WHADMIN_ALIGNCENTERED", false, 'static'); ?></option>
						<option value="clear"<?php if ($this->align=="clear") { echo " selected";}?>><?php echo WH_Lang::_("WHADMIN_ALIGNCLEAR", false, 'static'); ?></option>
					</select></dd>
					<?php break;
				case "page":
					break;
				case "pos":
					// pos list
					$pos = WH_Modules::getPosXML(); ?>
					<dt><?php echo WH_Lang::_("WHADMIN_PAGEPOSITION", false, 'static'); ?>:</<dt>
					<dd>
						<select name="parameter[pos]">
						<?php foreach ($pos as $k=>$p) {
							$selected = "";
							if ($this->pos == $k) { $selected = " selected"; }
							echo "<option$selected value=\"$k\">$p</option>";
						} ?>
					</select></dd>
					<?php break;
				case "title": ?>
					<dt><?php echo WH_Lang::_("WHADMIN_MODULETITLE", false, 'static'); ?>:</dt>
					<dd><input type="text" size="14" name="parameter[titel]" value="<?php echo $this->titel; ?>"></dd>
					<?php break;
			}
		}
		echo "</dl>
		</div>";
		return;
	}
	
	function retrieveLangQuery($query, $lang, $contentfield) {
		global $db, $cd;
		
		$ret = null;
		
		$db->select($query. " AND lang = '$lang'");
		$ret = (object) $db->get_row();
		if (!$ret->$contentfield) {
			// try to catch def language
			$db->select($query . " AND lang = '".$cd->getDefaultLang()."'");
			$ret = (object) $db->get_row();
			if (!$ret->$contentfield) {
				// try to catch other language
				$db->select($query);
				$ret = (object) $db->get_row();
			}
		}
		
		return $ret;
	}
	
	function hideAdminCode() {
		$ret = "<script language=\"javascript\">hideAdmin();</script>\n";
		$ret .= "<script language=\"javascript\">document.location.href = document.location;</script>";
		return $ret;
	}
	
	/**
	 * Placeholder edit function
	 *
	 */
	function edit() {
		echo "Nothing to edit.<br/><br/>";
		echo WH_HTML::hideAdminButton(WH_Lang::_("WHADMIN_CLOSE", false, 'static'), true);
		return;
	}
	
	/**
	 * Default delete function
	 *
	 * @param boolean $batch
	 */
	function delete($batch = false) {
		global $db;
 
		if ($this->hasLinks() > 0) {
			die(WH_HTML::delModWarning($this->titel));
		}
 
		$id = WH_Helper::get('modid');
		$db->update_sql("DELETE FROM module WHERE id = $id");
 
		if (!$batch) { echo $this->hideAdminCode(); }
	}
}

?>