<?php
/**
 * Cambio v0.5a
 * 
 * http://cambiocms.org/
 * @package Cambio
 */
if (defined("CAMBIO") or die("Access error"));

class WH_HTML {
	
	/**
	 * HTML class for WH website
	 *
	 * @return WH_HTML
	 */
	function WH_HTML() {
		// initialize
		// return true;
	}
	
	/**
	 * Render text block according to configuration
	 *
	 * @param unknown_type $input
	 */
	function _($input) {			
		global $cf;
		$parsefunction = "parse_".$cf->whParser;
		return self::$parsefunction($input);
	}
	
	function clean($input) {
		// markup set
		$input = trim($input);
		$input = htmlspecialchars($input);
		$input = nl2br($input);
		return $input;
	}
	
	function parse_bbcode($input) {
		// whitespace
		$input = trim($input);
		// html entities
		$input = WH_HTML::htmlspecialchars_nocodeblocks($input);
		// parse bbcode
		$input = WH_BBcode::parse($input);
		// newlines
		$input = nl2br($input);
		// return
		return $input;
	}
	
	function parse_cambio($input) {
		$input = WH_CambioParser::parse($input);
		return $input;
	}
	
	function htmlspecialchars_nocodeblocks($text) {
		$regex = "/\[code.*\[\/code\]/s";
		$nomatch = preg_split($regex, $text);
		preg_match($regex, $text, $match);		
		
		$res = array();
		foreach ($nomatch as $k => $item) {
			$res[] = htmlspecialchars($item);
			$res[] = $match[$k];
		}
		
		return implode("",$res);
	}
	
	function _default($toadd, &$ignorespaces) {
		if ($ignorespaces) {						
			if (trim($toadd)!="") {
				$ignorespaces = false;
				return $toadd;
			}
		} else {
			return $toadd;
		}
	}
		
	function editButton($modid, $task, $elmid = null, $buttontext = "edit", $confirm = false, $tooltip_header = null, $tooltip_body = null, $extraparam = null) {
		if ($buttontext == null) { $buttontext = "edit"; }
		global $wh;
		if (is_numeric($modid)) { $module = $wh->modules->$modid->module; } else { $module = $modid; }
		if ($confirm) { $confirm = "yes"; } else { $confirm = "no"; }
		$ret = "<div title=\"header=[$tooltip_header] body=[$tooltip_body]\" class=\"edit\" confirm=\"$confirm\" module=\"$module\" modid=\"$modid\" task=\"$task\" elmid=\"$elmid\" extra=\"$extraparam\">$buttontext</div>";
		return $ret;
	}
	
	function editDiv($modid, $task, $elmid = null, $confirm = false, $tooltip_header = null, $tooltip_body = null) {
		global $wh;
		$module = $wh->modules->$modid->module;
		if ($confirm) { $confirm = "yes"; } else { $confirm = "no"; }
		return "<div title=\"header=[$tooltip_header] body=[$tooltip_body]\" class=\"edit editable\" confirm=\"$confirm\" module=\"$module\" modid=\"$modid\" task=\"$task\" elmid=\"$elmid\">";
	}
	
	function adminLink($modid, $task = null, $elmid = null, $text = null, $confirm = false, $image = null, $extraparam = null) {
		if ($image) { return WH_HTML::adminImageLink($modid, $task, $elmid, $text, $confirm, $image, $extraparam); }
		$ret = WH_HTML::editButton($modid, $task, $elmid, $text, $confirm, null, null, $extraparam);
		return $ret;
	}
	
	function adminImageLink($modid, $task = null, $elmid = null, $text = null, $confirm = false, $image = null, $extraparam = null) {
		$ret = "<div class=\"imagelink\" style=\"background-image: url('tmpl/_default/images/admin_icons/small/$image.png');\">";
		$ret .= WH_HTML::editButton($modid, $task, $elmid, $text, $confirm, null, null, $extraparam);
		$ret .= "</div>";
		return $ret;
	}
	
	function editModuleButton($modid, $buttontext = 'edit') {
		global $wh;
		$module = $wh->modules->$modid->module;
		return "<div title=\"header=[".sprintf(WH_Lang::_("WHTIPHEADER_EDITMODULE", false, 'modules/modules'),$module)."] body=[".sprintf(WH_Lang::_("WHTIPBODY_EDITMODULE", false, 'modules/modules'),$module)."]\" class=\"edit\" confirm=\"no\" module=\"$module\" modid=\"$modid\" task=\"edit\" elmid=\"\">$buttontext</div>";
	}
	
	function deleteModuleButton($modid, $buttontext = 'delete') {
		global $wh;
		$module = $wh->modules->$modid->module;
		return "<div title=\"header=[".sprintf(WH_Lang::_("WHTIPHEADER_DELETEMODULE", false, 'modules/modules'),$module)."] body=[".sprintf(WH_Lang::_("WHTIPBODY_DELETEMODULE", false, 'modules/modules'),$module)."]\" class=\"edit\" confirm=\"yes\" module=\"$module\" modid=\"$modid\" task=\"delete\" elmid=\"\">$buttontext</div>";
	}
	
	function beginform($module, $task, $name = null, $extraparams = null) {
		if ($name) {
			$name = " name=\"$name\" id=\"$name\"";
		}
		return "<form$name onsubmit=\"admin('".WH_HTML::buildAdminURL($module, $task, false, null, $extraparams)."', this);return false;\" method=\"post\">";
	}	
	
	function endform($submittext = null, $dontendform = false, $nocancel = false) {
		if (is_null($submittext)) {
			$submittext = WH_Lang::_("WHADMIN_SUBMIT", false, "static");
		}
		$ret = "<input type=\"submit\" value=\"$submittext\">";
		if (!$nocancel) {
			$ret .= " <input type=\"button\" value=\"".WH_Lang::_("WHADMIN_CANCEL",false,'static')."\" onclick=\"hideAdmin();\">";
		}
		if (!$dontendform) {
			$ret .= "</form>";
		}
		return $ret;
	}
	
	function hideAdminButton($text = null, $refreshpage = false) {
		if (is_null($text)) {
			$text = WH_Lang::_("WHADMIN_CANCEL", false, "static");
		}
		if ($refreshpage) {
			$refreshcode = "document.location.href = document.location;";
		}
		return "<input type=\"button\" value=\"$text\" onclick=\"hideAdmin();$refreshcode\">";
	}
	
	function delModWarning($titel) {
		$ret = "Kan pagina of module niet verwijderen omdat er links bestaan naar een of meerdere modules op deze pagina<br/>of omdat een module op deze pagina een standaard-module is.<br/><br/>";
		$ret .= "Het gaat om de module: ".$titel."<br/><br/>";
		$ret .= WH_HTML::hideAdminButton('Oops');
		return $ret;
	}
	
	function buildURL($id, $moduleid = NULL, $task = NULL, $elmid = NULL) {
		// admin!
		if (!$id) {
			global $cd;
			$id = $cd->id;
		}
		$pages = WH_Pages::getInstance($id);
		// translate page title
		$titel = WH_Lang::_($pages->titel, false, "pages");
		$titel = str_replace(" ","_",$titel);
		//$titel = urlencode($titel);
		$titel = str_replace("&","&amp;",$titel);
		if ($moduleid && $task) {
			$task = "&amp;module=$moduleid&amp;task=$task";
		}
		if ($elmid) {
			$task .= "&amp;elmid=$elmid";
		}
		return "index.php?id={$id}:{$titel}{$task}";
	}
	
	function buildAdminURL($module, $task = NULL, $nohtmlamp = false, $elmid = NULL, $extraparams = null) {
		if (is_numeric($module)) {
			if ($nohtmlamp) {
				return "admin/index.php?modid={$module}&task={$task}&elmid={$elmid}&$extraparams";
			} else {
				return "admin/index.php?modid={$module}&amp;task={$task}&amp;elmid={$elmid}&$extraparams";
			}
		} else {
			if ($nohtmlamp) {
				return "admin/index.php?module={$module}&task={$task}&elmid={$elmid}&$extraparams";
			} else {
				return "admin/index.php?module={$module}&amp;task={$task}&amp;elmid={$elmid}&$extraparams";
			}
		}
	}
	
	function printAdminButtons($data) {
		$ret = "";
		if ($data) {
			foreach ($data as $item) {
				$ret .= "<div class=\"knop right\">";
				//.WH_HTML::deleteModuleButton($module->id, "Verwijder ".$module->module).
				$func = $item[0];
				array_shift($item);
				$class = new WH_HTML();
				$ret .= call_user_func_array(array($class, $func), $item);
				$ret .= "</div>";	
			}
		}
		return $ret;
	}
	
	function dump($var) {
		echo "Dump:<PRE>";
		print_r($var);
		echo "</PRE>";
	}
	
	function writeError($msg, $critical = false) {
		// print error message	
		echo $msg;
		// abort output?
		if ($critical) {
			exit();	
		}
	}
		
	/**
	 * function that gets rid of tabs, line breaks, and extra spaces
	 *
	 * @param string $buffer
	 * @return string
	 */
	function compress_html($html){ 
		preg_match_all('!(<(?:code|pre).*>[^<]+</(?:code|pre)>)!',$html,$pre);#exclude pre or code tags		 
		$html = preg_replace('!<(?:code|pre).*>[^<]+</(?:code|pre)>!', '#pre#', $html);#removing all pre or code tags		 
		$html = preg_replace('#<![^\[].+>#', '', $html);#removing HTML comments		 
		$html = preg_replace('/[\r\n\t]+/', ' ', $html);#remove new lines, spaces, tabs		 
		$html = preg_replace('/>[\s]+</', '><', $html);#remove new lines, spaces, tabs		 
		$html = preg_replace('/[\s]+/', ' ', $html);#remove new lines, spaces, tabs		 
		if(!empty($pre[0])) {
			foreach($pre[0] as $tag) {
				$html = preg_replace('!#pre#!', $tag, $html,1);#putting back pre|code tags		 
			}
		}
		return $html;		 
	}
	
	
	function noLangMarker($lang = null) {
		//return "\n(".WH_Lang::_("WH_ONLYAVAILABLEIN", false)." ".WH_Lang::_("WHLANG_TRANSLATED_".$lang, false).")";	
		$title = WH_Lang::_("WH_ONLYAVAILABLEIN", false)." ".WH_Lang::_("WHLANG_TRANSLATED_".$lang, false);
		//return "<span class=\"nolangmarker\">".WH_Lang::langFlag($lang, $title)." $title</span>";
		return "<span class=\"nolangmarker\">$title</span>";
	}
	
	function adminWarning($msg) {
		global $cd;
		$cd->warnings[] = $msg;
	}
	
	function adminMsg($msg) {
		global $cd;
		$cd->messages[] = $msg;
	}
	
	function adminPane($name, $modulename, $show = 1) {
		if ($name == "WHADMIN_GENERALPROPERTIES") {
			$langdir = 'static';
		} else {
			$langdir = "modules/$modulename";
		}
		$showButton = ($show==0) ? "block" : "none";
		$showPane = ($show==1) ? "block" : "none";
		$html = "<div style=\"display: $showButton;\" id=\"{$name}PaneButton\" class=\"showAdminPaneButton\"><a href=\"javascript:void(null)\" onclick=\"toggleAdminPane('{$name}Pane');\">".WH_Lang::_('WHADMIN_SHOW'.strtoupper($name).'PANE', false, $langdir)." &gt;</a></div>";
		$html .= "<div style=\"display: $showPane;\" id=\"{$name}Pane\" class=\"adminPane\">";
		$html .= "<div class=\"hideAdminPaneButton\"><a href=\"javascript:void(null)\" onclick=\"toggleAdminPane('{$name}Pane');\">&lt; ".WH_Lang::_('WHADMIN_HIDE'.strtoupper($name).'PANE', false, $langdir)."</a></div>";
		return $html;
	}
	
	function adminQuickButton($modname, $task, $buttontext, $image = null, $elmid = null, $confirm = false, $tooltip_header = null, $tooltip_body = null) {
		global $wh;
		$module = $modname;
		$modid = $wh->modules->getAdminModuleId($module);
		if ($confirm) { $confirm = "yes"; } else { $confirm = "no"; }
		return "<div title=\"header=[$tooltip_header] body=[$tooltip_body]\" class=\"edit quickbutton\" confirm=\"$confirm\" module=\"$module\" modid=\"$modid\" task=\"$task\" elmid=\"$elmid\">
			<img src=\"tmpl/_default/images/admin_icons/$image.png\" width=\"32\" height=\"32\" alt=\"\"/><br/>
			$buttontext
		</div>";
	}
	
}