<?php
/**
 * Cambio v0.5a
 * 
 * http://cambiocms.org/
 * @package Cambio
 */
if (defined("CAMBIO") or die("Access error"));

class WH_HTML_Table {
	
	var $_data = Array();
	var $_headers;
	var $_displaycolumns;
	
	var $_tableheader;
	var $_tablebody;
	var $_tablefooter;
	
	/**
	 * Creates new WH_HTML_Table class
	 *
	 * @param object $data Two dimensional array or object
	 * @return WH_HTML_Table
	 */
	function WH_HTML_Table($data = NULL) {
		if (is_array($data) || is_object($data)) {
			$this->_data = (array) $data;
			return true;
		} else {
			return false;
		}
	}
	
	/**
	 * Set columns to display
	 *
	 * @param array $displaycolumns
	 */
	function setDisplayColumns($displaycolumns) {
		$this->_displaycolumns = $displaycolumns;
	}
	
	/**
	 * Set headers
	 *
	 * @param array $headers
	 */
	function setHeaders($headers) {
		$this->_headers = $headers;
	}
	
	/**
	 * Add row to table
	 *
	 * @param array $data
	 */
	function addRow($data) {
		if (is_array($data) || is_object($data)) {
			array_push($this->_data, $data);
			return true;
		} else {
			return false;
		}
	}
	
	function render() {
		// start the table
		$this->_tablestart();
		
		// headers
		if ($this->_displaycolumns) {
			// display only selected column headers
			$temp = (array) $this->_data;
			$row = array_shift($temp);
			$this->_rowstart($this->_tableheader);
			foreach ((array) $row as $column => $value) {
				if (in_array($column, $this->_displaycolumns)) {						
					$this->_columnstart($this->_tableheader);
					// get array headers
					if (!isset($this->_headers[$column])) {
						$this->_appendtotable($column, $this->_tableheader);
					} else {
						$this->_appendtotable($this->_headers[$column], $this->_tableheader);
					}
					$this->_columnend($this->_tableheader);
				}
			}
			$this->_rowend($this->_tableheader);
		} else {
			// display all headers
			$temp = (array) $this->_data;
			$row = array_shift($temp);	
			$this->_rowstart($this->_tableheader);
			foreach ((array) $row as $column => $value) {
				$this->_columnstart($this->_tableheader);
				if (!isset($this->_headers[$column])) {
					$this->_appendtotable($column, $this->_tableheader);
				} else {
					$this->_appendtotable($this->_headers[$column], $this->_tableheader);
				}
				$this->_columnend($this->_tableheader);
			}
			$this->_rowend($this->_tableheader);
		}
		
		// data
		if ($this->_displaycolumns) {
			// display only selected columns
			foreach ((array) $this->_data as $row) {
				$this->_rowstart($this->_tablebody);
				foreach ((array) $row as $column => $value) {
					if (in_array($column, $this->_displaycolumns)) {						
						$this->_columnstart($this->_tablebody);
						$this->_appendtotable($value, $this->_tablebody);
						$this->_columnend($this->_tablebody);
					}
				}
				$this->_rowend($this->_tablebody);
			}
		} else {
			// display all data
			foreach ((array) $this->_data as $row) {
				$this->_rowstart($this->_tablebody);
				foreach ((array) $row as $value) {
					$this->_columnstart($this->_tablebody);
					$this->_appendtotable($value, $this->_tablebody);
					$this->_columnend($this->_tablebody);
				}
				$this->_rowend($this->_tablebody);
			}
		}
		
		// display
		echo "<thead>";
		echo $this->_tableheader;
		echo "</thead>";
		echo "<tfoot>";
		echo $this->_tablefooter;
		echo "</tfoot>";
		echo "<tbody>";
		if ($this->_tablebody) {
			echo $this->_tablebody;
		} else {
			echo "<tr><td>".WH_Lang::_("NOTABLEDATA",false,"static")."</td></tr>";
		}
		echo "</tbody>";
		
		// end the table
		$this->_tableend();
	}
	
	function _rowstart(&$table) {
		$this->_appendtotable("<tr>", $table);
	}
	
	function _rowend(&$table) {
		$this->_appendtotable("</tr>", $table);
	}
	
	function _columnstart(&$table) {
		$this->_appendtotable("<td><span>", $table);
	}
	
	function _columnend(&$table) {
		$this->_appendtotable("</span></td>", $table);
	}
	
	function _tablestart() {
		echo "<table cellspacing=\"1\" cellpadding=\"3\" class=\"admintable\">";
	}
	
	function _tableend() {
		echo "</table>";
	}
	
	function _appendtotable($value, &$table) {
		$table .= $value;
	}
	
	
}