<?php
/**
 * Cambio v0.5a
 * 
 * http://cambiocms.org/
 * @package Cambio
 */
if (defined("CAMBIO") or die("Access error"));

class WH_HTML_Image {
	
	var $type = "";
	var $image = "";
	
	function WH_HTML_Image($file) {
		$this->type = $this->file_extension($file);
		switch ($this->type) {
			case "jpg": 
				$this->image = imagecreatefromjpeg($file);
				break;
			case "png":
				$this->image = imagecreatefrompng($file);
				break;
			case "gif":
				$this->image = imagecreatefromgif($file);
				break;
		}
	}
	
	function resize($dim, $w_or_h) {
		
		$old_x=imageSX($this->image);
		$old_y=imageSY($this->image);
			
		if ($w_or_h = "w") {
			$thumb_w=$new_w;
			$thumb_h=$old_y*($new_w/$old_x);
		}
		if ($w_or_h = "h") {
			$thumb_w=$old_x*($new_h/$old_y);
			$thumb_h=$new_h;
		}
		
		$newimage = ImageCreateTrueColor($thumb_w,$thumb_h);
		
		$this->fastimagecopyresampled($newimage,$this->image,0,0,0,0,$thumb_w,$thumb_h,$old_x,$old_y,5);
		
		$this->image = $newimage;		
	}
	
	function crop($height, $width) {
		
		// no x or y correction
		$x_o = 0; //intval($_GET["x"]);
		$y_o = 0; //intval($_GET["y"]);
		
		$newimage=ImageCreateTrueColor($width,$height);
		
		$old_x=imageSX($this->image);
		$old_y=imageSY($this->image);
				
		$thumb_w=$width;
		$thumb_h=intval($old_y*($width/$old_x));
		
		$x_offset = 0;
		$y_offset = 0;
		
		if ($thumb_h < $height) {
			$thumb_h=$height;
			$thumb_w=intval($old_x*($height/$old_y));
				
			// hoogte kleiner dan breedte
			$x_offset = intval(($thumb_w - $width) / 2);
			//$x_offset = $x_offset * 2;
						
		} else {
			
			// hoogte groter
			$y_offset = ($thumb_h - $height) / 2;
			//$y_offset = $y_offset * 2;
			
		}
		
		$x_offset = $x_offset + $x_o;
		$y_offset = $y_offset + $y_o;
		
		$this->fastimagecopyresampled($newimage,$this->image,-$x_offset,-$y_offset,0,0,$thumb_w,$thumb_h,$old_x,$old_y,5);
		
		$this->image = $newimage;
	}
	
	function save($target) {
		switch ($this->type) {
			case "jpg": 
				imagejpeg($this->image,$target);
				break;
			case "png":
				imagepng($this->image,$target);
				break;
			case "gif":
				imagegif($this->image,$target);
				break;
		}
	}
	
	function output() {
		switch ($this->type) {
			case "jpg": 
				header("Content-Type: image/jpeg");
				imagejpeg($this->image);
				break;
			case "png":
				header("Content-Type: image/png");
				imagepng($this->image);
				break;
			case "gif":
				header("Content-Type: image/gif");
				imagegif($this->image);
				break;
		}
	}
	
	function destroy() {
		imagedestroy($this->image); 
	}
	
	function file_extension($filename) {
	    $path_info = pathinfo($filename);
	    return strtolower($path_info['extension']);
	}
	
	function fastimagecopyresampled (&$dst_image, $src_image, $dst_x, $dst_y, $src_x, $src_y, $dst_w, $dst_h, $src_w, $src_h, $quality = 3) {
		// Plug-and-Play fastimagecopyresampled function replaces much slower imagecopyresampled.
		// Just include this function and change all "imagecopyresampled" references to "fastimagecopyresampled".
		// Typically from 30 to 60 times faster when reducing high resolution images down to thumbnail size using the default quality setting.
		// Author: Tim Eckel - Date: 09/07/07 - Version: 1.1 - Project: FreeRingers.net - Freely distributable - These comments must remain.
		//
		// Optional "quality" parameter (defaults is 3). Fractional values are allowed, for example 1.5. Must be greater than zero.
		// Between 0 and 1 = Fast, but mosaic results, closer to 0 increases the mosaic effect.
		// 1 = Up to 350 times faster. Poor results, looks very similar to imagecopyresized.
		// 2 = Up to 95 times faster.  Images appear a little sharp, some prefer this over a quality of 3.
		// 3 = Up to 60 times faster.  Will give high quality smooth results very close to imagecopyresampled, just faster.
		// 4 = Up to 25 times faster.  Almost identical to imagecopyresampled for most images.
		// 5 = No speedup. Just uses imagecopyresampled, no advantage over imagecopyresampled.
		
		if (empty($src_image) || empty($dst_image) || $quality <= 0) { return false; }
		if ($quality < 5 && (($dst_w * $quality) < $src_w || ($dst_h * $quality) < $src_h)) {
		$temp = imagecreatetruecolor ($dst_w * $quality + 1, $dst_h * $quality + 1);
		imagecopyresized ($temp, $src_image, 0, 0, $src_x, $src_y, $dst_w * $quality + 1, $dst_h * $quality + 1, $src_w, $src_h);
		imagecopyresampled ($dst_image, $temp, $dst_x, $dst_y, 0, 0, $dst_w, $dst_h, $dst_w * $quality, $dst_h * $quality);
		imagedestroy ($temp);
		} else imagecopyresampled ($dst_image, $src_image, $dst_x, $dst_y, $src_x, $src_y, $dst_w, $dst_h, $src_w, $src_h);
		return true;
	}
	
}