<?php
/**
 * Cambio v0.5a
 * 
 * http://cambiocms.org/
 * @package Cambio
 */
if (defined("CAMBIO") or die("Access error"));

class WH_CambioParser extends WH_Parser {
	
	/**
	 * Cambio arser class for Cambio
	 *
	 * @return WH_CambioParser
	 */
	function WH_CambioParser() {
		// initialize
	}
	
	function parse($input) {
		// whitespace
		$input = trim($input);
		$input = htmlspecialchars($input);
		// walk throug string for markup codes
		$tmp = "";
		$closetag = "";
		$ignorespaces = false;
		$lookfor = "";
		$target = "";
		$linktekst = "";
		$lasti = 0;
		for ($i=0;$i<strlen($input);$i++) {
			$code = substr($input, $i, 3);
			if ($code == "[l:") {
				$lookfor = "link";
				$lasti = $i+3;
			} elseif ($code == "[int=") {
				$lookfor = "link";
				$lasti = $i+5;
			} elseif ($code == "[b]" || $code == "[i]" || $code == "[u]") {
				$lookfor = "markup";
			} elseif ($code == "[1]" || $code == "[2]" || $code == "[3]") {
				$lookfor = "header";
			}
			switch ($lookfor) {
				case "header":
					if (substr($input, $i, 2)=="[]") {
						$lookfor = "";
						$tmp .= $closetag;
						$ignorespaces = true;
						$i++;
					} else {
						if ($code == "[1]" || $code == "[2]" || $code == "[3]") {
							$opentag = "</p><h".substr($code,1,1).">";
							$closetag = "</h".substr($code,1,1)."><p>";
							$tmp = trim($tmp);
							$tmp .= $opentag;
							$i += 2;
						} else {
							$tmp .= substr($input, $i, 1);
						}
					}					
					break;
				case "markup":
					if (substr($input, $i, 2)=="[]") {
						$lookfor = "";
						$tmp .= "</span>";
						$i++;
					} else {
						if ($code=="[b]") {
							$tmp .= "<span class=\"dik\">";
							$i += 2;
						} elseif ($code=="[i]") {
							$tmp .= "<span class=\"schuin\">";
							$i += 2;
						} elseif ($code=="[u]") {
							$tmp .= "<span class=\"lijn\">";
							$i += 2;
						} else {
							$tmp .= WH_HTML::_default(substr($input, $i, 1), $ignorespaces);
						}
					}					
					break;
				case "link":
					if (substr($input, $i, 1)=="]") {
						$link = substr($input, $lasti, $i-$lasti);
						if (is_numeric($link)) {
							$link = WH_HTML::buildURL($link);
							$linktekst = substr($link,strpos($link, ":")+1,strlen($link)-strpos($link, ":")-1);							
							if ($linktekst == "") {
								$link = "";
							}
							$target = "_self";
						} else {
							if (strpos($link, "@")>0 && strpos($input, "mailto:") === false) {
								$linktekst = $link;
								$link = "mailto:".$link;
								$target = "_self";
							} else {
								if (strpos($input, "mailto:") === false) {
									if (substr($link,0,7)!="http://") {
										$linktekst = $link;
										$link = "http://".$link;
									} else {
										$linktekst = str_replace("http://","",$link);
									}
									$target = "_blank";
								} else {
									$linktekst = str_replace("mailto:","",$link);
									$target = "_self";
								}
							}
						}
						$lasti = $i+1;
					}
					if (substr($input, $i, 2)=="[]") {
						$text = substr($input, $lasti, $i-$lasti);
						if ($text == "") {
							if ($linktekst != "") {
								$text = $linktekst;
							} else {
								$text = "(foutieve link)";
							}
						}
						if ($link == "") {
							$text = "(foutieve link)";
						}
						$lookfor = "";
						$tmp .= "<a target=\"$target\" href=\"$link\">$text</a>";
						$i = $i + 1;
					}
					break;
				default:
					$tmp .= WH_HTML::_default(substr($input, $i, 1), $ignorespaces);
			}
		}
		
		$tmp = nl2br($tmp);		
		return $tmp;		
	}
}