<?php
/**
 * Cambio v0.5a
 * 
 * http://cambiocms.org/
 * @package Cambio
 */
if (defined("CAMBIO") or die("Access error"));

class WH_Helper {
	
	/**
	 * Helper class for WH website
	 *
	 * @return WH_Helper
	 */
	function WH_Helper() {
		// initialize
		// return true;
	}
	
	function get($var = '*', $from = "get", $default = null) {
		global $cd;
		switch ($from) {
			case "get":
				if (!isset($cd->_get)) {
					$cd->_get = $_GET;
				}
				if ($var == '*') {
					$ret = $cd->_get;
				} else {
					$ret = $cd->_get[$var];
				}
				break;	
			case "post":	
				if (!isset($cd->_post)) {
					$cd->_post = $_POST;
				}
				if ($var == '*') {
					$ret = $cd->_post;
				} else {
					$ret = $cd->_post[$var];
				}
				break;
			case "session":
				if (!isset($cd->_session)) {
					$cd->_session = $_SESSION;
				}
				if ($var == '*') {
					$ret = $cd->_session;
				} else {
					$ret = $cd->_session[$var];
				}
				break;
			case "cookie":
				if (!isset($cd->_cookie)) {
					$cd->_cookie = $_COOKIE;
				}
				if ($var == '*') {
					$ret = $cd->_cookie;
				} else {
					$ret = $cd->_cookie[$var];
				}
				break;
		}
		if (isset($ret)) {
			if (is_array($ret)) {
				array_walk($ret, 'urld');
			} else {
				$ret = urldecode($ret);
			}
			return $ret;
		} else {
			return $default;
		}
	}
	
	function set($var, $value, $to = "get") {
		global $cd;
		switch ($to) {
			case "get":
				if (!isset($cd->_get)) {
					$cd->_get = $_GET;
				}
				$cd->_get[$var] = $value;
				break;	
			case "post":	
				if (!isset($cd->_post)) {
					$cd->_post = $_POST;
				}
				$cd->_post[$var] = $value;
				break;
			case "session":
				if (!isset($cd->_session)) {				
					$cd->_session = $_SESSION;
				}
				$cd->_session[$var] = $value;
				$_SESSION[$var] = $value;
				break;
			case "cookie":
				if (!isset($cd->_cookie)) {				
					$cd->_cookie = $_COOKIE;
				}
				$cd->_cookie[$var] = $value;
				setcookie($var, $value, time()+60*60*24*90);
				break;
		}
	}
	
	function getPlugin($name) {
		global $cf;
		$pluginpath = $cf->whDir."plugin".$cf->whDS.$name.$cf->whDS.$name.".php";		
		if (file_exists($pluginpath)) {
			include($pluginpath);
			
			$plugincss = $cf->whDir."plugin".$cf->whDS.$name.$cf->whDS."css".$cf->whDS.$name.".css";
			$pluginjs = $cf->whDir."plugin".$cf->whDS.$name.$cf->whDS."js".$cf->whDS.$name.".js";
			global $cd;
			if (file_exists($plugincss) && WH_Helper::get('show')!='module') {
				?>
				<script type="text/javascript">addStylesheet('<?php echo "plugin/".$name."/css/".$name.".css"; ?>');</script>
				<?php
			}
			if (file_exists($pluginjs) && WH_Helper::get('show')!='module') {
				?>
				<script type="text/javascript">addJavascript('<?php echo "plugin/".$name."/js/".$name.".js"; ?>');</script>
				<?php
			}
			$className = "WH_Plugin".$name;
			$ret = new $className;
			return $ret;
		} else {
			WH_HTML::writeError("Plugin $name not found", true);
		}
	}
}

/**
 * Array walk helper function to decode string
 *
 * @param unknown_type $item
 */
function urld(&$item) {
	if (is_array($item)) {
		array_walk($item, 'urld');
	} else {
		$item = urldecode($item);
	}
}
