<?php
/* vim: set expandtab tabstop=4 shiftwidth=4: */
// +----------------------------------------------------------------------+
// | PHP Version 4                                                        |
// +----------------------------------------------------------------------+
// | Copyright (c) 1997-2003 The PHP Group                                |
// +----------------------------------------------------------------------+
// | This source file is subject to version 2.02 of the PHP license,      |
// | that is bundled with this package in the file LICENSE, and is        |
// | available at through the world-wide-web at                           |
// | http://www.php.net/license/2_02.txt.                                 |
// | If you did not receive a copy of the PHP license and are unable to   |
// | obtain it through the world-wide-web, please send a note to          |
// | license@php.net so we can mail you a copy immediately.               |
// +----------------------------------------------------------------------+
// | Author: Stijn de Reede <sjr@gmx.co.uk>                               |
// +----------------------------------------------------------------------+
//
// $Id: Links.php,v 1.12 2007/07/02 18:26:17 cweiske Exp $
//

/**
* @package  HTML_BBCodeParser
* @author   Stijn de Reede  <sjr@gmx.co.uk>
*/
require_once 'cms/includes/bbcode/BBCodeParser/Filter.php';

/**
 *
 */
class HTML_BBCodeParser_Filter_Code extends HTML_BBCodeParser_Filter
{
    /**
     * An array of tags parsed by the engine
     *
     * @access   private
     * @var      array
     */
    /*
    // do we really need this?
    var $_definedTags = array(
        'url' => array(
            'htmlopen'  => 'a',
            'htmlclose' => 'a',
            'allowed'   => 'none^img',
            'attributes'=> array('url' => 'href=%2$s%1$s%2$s')
        )
    );*/
    
    var $_geshi;


    /**
     * @return   none
     * @access   private
     * @see      $_text
     */
    function _preparse()
    {
        $options = $this->_options;
        $o = $options['open'];
        $c = $options['close'];
        $oe = $options['open_esc'];
        $ce = $options['close_esc'];


        $pattern = "/\[code\=([^\]]*)\]([^\[]*)\[\/code\]/s";
        
        $pp = preg_replace_callback($pattern, array($this, "_makeCode"), $this->_text);
        $this->_preparsed = $pp;

    }
    
    function _makeCode($match) {
    	global $cd, $cf;
    	
    	if (!isset($this->_geshi)) {
    		$this->_geshi = new WH_GeSHi();
    	}
    	
    	$cssstylesdir = 'cms/includes/geshi/css/geshi.css';
    	$csscontainerdir = 'cms/includes/geshi/css/container.css';
    	if (!in_array($csscontainerdir, $cd->stylesheets)) {
    		if ($cf->whGeshiUseStylsheet) {
    			$cd->stylesheets[] = $cssstylesdir;
    		}
    		$cd->stylesheets[] = $csscontainerdir;
    	}
    	
    	return $this->_geshi->parse(trim($match[2]), $match[1]);
    }
    
}
?>