<?php
/**
 * Cambio v0.5a
 * 
 * http://cambiocms.org/
 * @package Cambio
 */
if (defined("CAMBIO") or die("Access error"));

$cf = (object) Array("whDS"=>"/");
$cd = (object) Array("lang"=>"en");

// include helper class
include('includes/999_helper.php');
include('includes/100_mysql.php');
include('includes/150_database.php');
include('includes/600_html.php');
include('includes/300_lang.php');

if (isset($_GET["lang"])) {
	$cd->lang = $_GET["lang"];
	WH_Helper::set('lang_install', $cd->lang, 'cookie');
}
if (!is_null(WH_Helper::get('lang_install', 'cookie', null))) {
	$cd->lang = WH_Helper::get('lang_install', 'cookie');
}
?>

<html><head><title><?php echo WH_Lang::_("WH_INSTALLWHCMS", false, "install"); ?></title></head><body>

<p>Choose your language:
<select name="lang" onchange="document.installform.submitted.value='0';document.installform.action='index.php?lang='+this.value;document.installform.submit();">
	<option value="">(choose)</option>
	<option value="en">English</option>
	<option value="nl">Nederlands</option>
</select>
</p>

<h1><?php echo WH_Lang::_("WH_INSTALLWHCMS", false, "install"); ?></h1>

<?php

$post = (object) WH_Helper::get("*", "post");

if (
	(!$post->whSitename ||
	!$post->whDescription ||
	!$post->whKeywords ||
	!$post->whLang ||
	!$post->whDir ||
	!$post->whUrl ||
	!$post->whDatabase ||
	!$post->whDbUser ||
	!$post->whDbPass ||
	!$post->whAdminPassword
	) && $post->submitted == 1) {
		// ingevuld maar niet volledig
		echo "<span style=\"color: red;\">".WH_Lang::_("WH_FILLINALLFIELDS",false,'static')."</span>";
		writeStep1();
	} elseif ($post->submitted == 1) {
		echo WH_Lang::_("WH_CONNECTINGDB",false,'install')."<br/>";
		// alles is ingevuld, db testen!
		$db = new WH_Database();
		error_reporting(0);
		if ($db->init($post->whDatabase, $post->whDbUser, $post->whDbPass)==false) {
			// database error
			echo WH_Lang::_("WH_DBERROR",false,'install')."<br/>";
			error_reporting(E_ALL ^ E_NOTICE);
			writeStep1();
		} else {
			echo WH_Lang::_("WH_DBCONNECTED",false,'install')."<br/>";
			error_reporting(E_ALL ^ E_NOTICE);
			// succes!
			writeStep2();
		}
	} else {
		// niks ingevuld
		writeStep1();
	}
	
function checkDirs($show = false, $chmod = false) {
	$tocheck = Array(
		"config/",
		"media/",
		"css/",
		"js/",
		"tmp/",
		"cache/",
		"languages/"
		);
	$fail = false;
	foreach ($tocheck as $check) {
		if (!is__writable($check)) {
			$fail = true;
			if ($chmod) {
				error_reporting(0);
				chmodDirectory(substr($check, 0, -1), 0, $show);
				error_reporting(E_ALL ^ E_NOTICE);
				$fail = false;
			} else {
				if ($show) {
					echo "<span style=\"color: red;\">".sprintf(WH_Lang::_("WH_DIRNOTWRITABLE",false,"install"), $check)."</span><br/>";
				}
			}
		} else {
			if ($show && !$chmod) {
				echo "<span style=\"color: green;\">".sprintf(WH_Lang::_("WH_DIRWRITABLE",false,"install"), $check)."</span><br/>";
			}
		}
	}
	if ($fail) {
		return false;
	} else {
		return true;
	}
}

 function chmodDirectory( $path = '.', $level = 0, $show = false ){  

    $ignore = array( 'cgi-bin', '.', '..' ); 

    $dh = @opendir( $path ); 
	    
    while( false !== ( $file = readdir( $dh ) ) ){ // Loop through the directory 

      if( !in_array( $file, $ignore ) ){
        if( is_dir( "$path/$file" ) ){
          $succes = chmod("$path/$file",0777);
          if ($show && $succes) {
			echo "<span style=\"color: green;\">".sprintf(WH_Lang::_("WH_CHMODSUCCESS",false,"install"), "$path/$file")."</span><br/>";
		  } elseif ($show && !$succes) {
		  	echo "<span style=\"color: red;\">".sprintf(WH_Lang::_("WH_CHMODFAILED",false,"install"), "$path/$file")."</span><br/>";
		  }
          chmodDirectory( "$path/$file", ($level+1), $show);
        } else {
          $succes = chmod("$path/$file",0777); // desired permission settings
          if ($show && $succes) {
			echo "<span style=\"color: green; margin-left: 40px;\">".sprintf(WH_Lang::_("WH_CHMODSUCCESS",false,"install"), "$file")."</span><br/>";
		  } elseif ($show && !$succes) {
		  	echo "<span style=\"color: red; margin-left: 40px;\">".sprintf(WH_Lang::_("WH_CHMODFAILED",false,"install"), "$file")."</span><br/>";
		  }
        }//elseif 

      }//if in array 

    }//while 
    
    closedir( $dh ); 
    
  }//function

function executeSqlFile($file) {
	global $db;
	
	/* Read the file */
	$lines = file($file);
	
	if(!$lines) {
	  echo WH_Lang::_("WH_SQLFILEERROR",false,'install')."<br/>";
	  return false;
	}
	
	$scriptfile = false;
	
	foreach($lines as $line) {
	  $line = trim($line);
	  if(!preg_match('/^--/', $line)) {
	     $scriptfile.=" ".$line;
	  }
	}
	
	if(!$scriptfile) {
	  echo WH_Lang::_("WH_NOQUERIESINSQLFILE",false,'install')."<br/>";
	  return false;
	}
	
	$queries = explode(';', $scriptfile);
	
	foreach($queries as $query) {
	  $query = trim($query);
	  if($query == "") { continue; }
	  if(!$db->update_sql($query.';')) {
	     echo WH_Lang::_("WH_QUERYFAILED",false,'install')."<br/>";
	     $db->print_last_error();
	     return false;
	  }
	}
	return true;
}

function writeStep2() {
	global $db, $post;
	echo WH_Lang::_("WH_WRITINGTABLESTRUCTURE",false,'install')."<br/>";
	
	$sqloperation = executeSqlFile("cms/sql/structure.sql");
	if ($sqloperation == true) {
   		echo WH_Lang::_("WH_DBSTRUCTURESUCCESS",false,'install')."<br/>";
	} else {
		return false;
	}
	
	$sample = $post->sample;
	if ($sample=="ja") {
		
		// sample data
		echo WH_Lang::_("WH_INSERTSAMPLEDATA",false,'install')."<br/>";		
		$sqloperation = executeSqlFile("cms/sql/sample.sql");
		if ($sqloperation == true) {
	   		echo WH_Lang::_("WH_SAMPLEDATAINSERTED",false,'install')."<br/>";
		} else {
			return false;
		}
	   
		
	} else {
	
		// basic data
		echo WH_Lang::_("WH_INSERTBASICDATA",false,'install')."<br/>";		
		$sqloperation = executeSqlFile("cms/sql/simple.sql");
		if ($sqloperation == true) {
	   		echo WH_Lang::_("WH_BASICDATAINSERTED",false,'install')."<br/>";
		} else {
			return false;
		}
		
	}
	
	// admin account
	echo WH_Lang::_("WH_CREATEADMINACCOUNT",false,'install')."<br/>";
	if (!$db->insert_array("users", Array("user"=>"admin", "pass"=>md5($post->whAdminPassword), "usertype_id"=>2))) { echo WH_Lang::_("WH_QUERYFAILED",false,'install')."<br/>"; $db->print_last_error(); return false; }
	echo WH_Lang::_("WH_ADMINACCOUNTCREATED",false,'install')."<br/>";
	
	// config file
	echo WH_Lang::_("WH_WRITECONFIG",false,'install')."<br/>";
   
	if (!saveconf()) {
		echo WH_Lang::_("WH_WRITECONFIGERROR",false,'install')."<br/>";
	} else {
		echo WH_Lang::_("WH_CONFIGWRITTEN",false,'install')."<br/>";
		?>
		<h3><?php echo WH_Lang::_("WH_CONGRATS",false,'install'); ?></h3>
		<p>
			<?php echo WH_Lang::_("WH_CONGRATS1",false,'install'); ?>
			<a href="<?php echo $post->whUrl."admin";?>"><?php echo $post->whUrl."admin";?></a>
			<?php echo WH_Lang::_("WH_CONGRATS2",false,'install'); ?>
		</p>
		<table>
		<tr>
			<td><b><?php echo WH_Lang::_("WH_USER",false,'modules/login'); ?></b>:</td>
			<td>admin</td>
		</tr>
		<tr>
			<td><b><?php echo WH_Lang::_("WH_PASSWORD",false,'modules/login'); ?></b>:</td>
			<td><?php echo $post->whAdminPassword;?></td>
		</tr>		
		</table>
		<?php
	}
   
   return true;
}

function saveconf() {
	global $post;
	$conf = "<?php if (defined(\"CAMBIO\") or die(\"Access error\"));\n
class WH_Config {\n";
	foreach ($post as $k => $v) {
		// BOOLEANS AND INTEGERS!
		if ($k=="whHomepage"||$k=="whCache"||$k=="whLoginPage"||$k=="whDebug"||$k=="whLanguageAutoDetect") {
			$conf .= "\t var $".$k." = ".$v.";\n";
		} elseif ($k=="whDS") {
			$conf .= "\t var $".$k." = \"".str_replace("\\", "\\\\", $v)."\";\n";
		} elseif ($k=="whAdminPassword"||$k=="submitted"||$k=="sample") {
		} else {
			$conf .= "\t var $".$k." = \"".str_replace("\"","\\\"",$v)."\";\n";
		}
	}
	$conf .= "}\n?>";
	
	$confFile = "config/config.php";
	//if (file_exists($confFile)) {
		if (!$fh = fopen($confFile, 'w')) {
			echo WH_Lang::_('WH_OPENCONFIGERROR',false,'install');
			return false;
		}
		fwrite($fh, $conf);
		fclose($fh);
	//} else {
	//	echo "Can't find config file<br/>";
	//	return false;
	//}
	return true;
}
	
function writeStep1() { 
	global $post; ?>

<form action="index.php" name="installform" method="POST">

<table>
<tr>
	<td colspan="2"><h2><?php echo WH_Lang::_('WHADMIN_GENERAL',false,'modules/config');?></h2></td>
</tr>
<tr>
	<td><?php echo WH_Lang::_('WHADMIN_TITLE',false,'modules/config');?>:</td>
	<td><input name="whSitename" type="text" value="<?php echo $post->whSitename; ?>" size="60"></td>
</tr>
<tr>
	<td><?php echo WH_Lang::_('WHADMIN_DESCRIPTION',false,'modules/config');?>:</td>
	<td><textarea cols="60" rows="5" name="whDescription"><?php echo $post->whDescription; ?></textarea></td>
</tr>
<tr>
	<td><?php echo WH_Lang::_('WHADMIN_KEYWORDS',false,'modules/config');?>:</td>
	<td><textarea cols="60" rows="5" name="whKeywords"><?php echo $post->whKeywords; ?></textarea></td>
</tr>
<tr>
	<td><?php echo WH_Lang::_('WHADMIN_LANGUAGE',false,'modules/config');?> <?php echo WH_Lang::_('WHADMIN_LANGUAGEHELP',false,'modules/config');?>:</td>
	<td><input name="whLang" type="text" value="<?php echo $post->whLang; ?>" size="4"> <?php echo WH_Lang::_('WH_LANGUAGEDEFAULT',false,'install');?></td>
</tr>
<tr>
	<td><?php echo WH_Lang::_('WHADMIN_HOMEPAGE',false,'modules/config');?>:</td>
	<td><input name="whHomepage" type="hidden" value="1">1</td>
</tr>
<tr>
	<td><?php echo WH_Lang::_('WHADMIN_WHCMSLOGINPAGE',false,'modules/config');?>:</td>
	<td><input name="whLoginPage" type="hidden" value="2">2</td>
</tr>
<tr>
	<td><?php echo WH_Lang::_('WHADMIN_DEBUG',false,'modules/config');?>:</td>
	<td><select name="whDebug">
		<option value="false"<?php if ($post->whDebug=="false") { echo " selected"; }?>>Nee</option>
		<option value="true"<?php if ($post->whDebug=="true") { echo " selected"; }?>>Ja</option>
	</select></td>
</tr>
<tr>
	<td><?php echo WH_Lang::_('WH_INSTALLSAMPLE',false,'install');?></td>
	<td><input type="checkbox" name="sample" <?php if ($post->sample!=false) { echo "checked"; }?> value="ja"/></td>
</tr>
<tr>
	<td colspan="2"><h3><?php echo WH_Lang::_('WHADMIN_HTTPSERVER',false,'modules/config');?></h3></td>
</tr>
<tr>
	<td><?php echo WH_Lang::_('WHADMIN_LANGUAGEAUTODETECT',false,'modules/config');?>:</td>
	<td><select name="whLanguageAutoDetect">
		<option value="true"<?php if ($post->whLanguageAutoDetect=="true") { echo " selected"; }?>><?php echo WH_Lang::_('WHADMIN_YES',false,'modules/config');?></option>
		<option value="false"<?php if ($post->whLanguageAutoDetect=="false") { echo " selected"; }?>><?php echo WH_Lang::_('WHADMIN_NO',false,'modules/config');?></option>
	</select></td>
</tr>
<tr>
	<td><?php echo WH_Lang::_('WHADMIN_CACHE',false,'modules/config');?>:</td>
	<td><select name="whCache">
		<option value="false"<?php if ($post->whCache=="false") { echo " selected"; }?>><?php echo WH_Lang::_('WHADMIN_NO',false,'modules/config');?></option>
		<option value="true"<?php if ($post->whCache=="true") { echo " selected"; }?>><?php echo WH_Lang::_('WHADMIN_YES',false,'modules/config');?></option>
	</select></td>
</tr>
<tr>
	<td><?php echo WH_Lang::_('WHADMIN_DS',false,'modules/config');?>:</td>
	<td><select name="whDS">
		<option value="/"<?php if ($post->whDS=="/") { echo " selected"; }?>>/ (Linux)</option>
		<option value="\"<?php if ($post->whDS=="\\") { echo " selected"; }?>>\ (Windows)</option>
	</select></td>
</tr>
<tr>
	<td><?php echo WH_Lang::_('WHADMIN_BASEDIR',false,'modules/config');?>:</td>
	<td><input id="whDir" name="whDir" type="text" value="<?php if ($post->whDir) { echo $post->whDir; } else { echo str_replace("index.php","",$_SERVER['SCRIPT_FILENAME']);} ?>" size="60"> <input type="button" value="&lt; Standaard" onclick="document.getElementById('whDir').value='<?php echo str_replace("index.php","",$_SERVER['SCRIPT_FILENAME']);?>';"></td>
</tr>
<tr>
	<td><?php echo WH_Lang::_('WHADMIN_BASEURL',false,'modules/config');?>:</td>
	<td><input id="whUrl" name="whUrl" type="text" value="<?php if ($post->whUrl) { echo $post->whUrl; } else { echo "http://".$_SERVER['HTTP_HOST'].str_replace("index.php","",$_SERVER['SCRIPT_NAME']);} ?>" size="60"> <input type="button" value="&lt; Standaard" onclick="document.getElementById('whUrl').value='http://<?php echo $_SERVER['HTTP_HOST'].str_replace("index.php","",$_SERVER['SCRIPT_NAME']);?>';"></td>
</tr>
<tr>
	<td colspan="2"><h3><?php echo WH_Lang::_('WHADMIN_DBSERVER',false,'modules/config');?></h3><p style="color: red;"><?php echo WH_Lang::_('WH_DBWARNING',false,'install');?></p></td>
</tr>
<tr>
	<td><?php echo WH_Lang::_('WHADMIN_DBNAME',false,'modules/config');?>:</td>
	<td><input name="whDatabase" type="text" value="<?php echo $post->whDatabase; ?>" size="30"></td>
</tr>
<tr>
	<td><?php echo WH_Lang::_('WHADMIN_DBUSER',false,'modules/config');?>:</td>
	<td><input name="whDbUser" type="text" value="<?php echo $post->whDbUser; ?>" size="30"></td>
</tr>
<tr>
	<td><?php echo WH_Lang::_('WHADMIN_DBPASSWORD',false,'modules/config');?>:</td>
	<td><input id="whDbPass" name="whDbPass" type="text" value="<?php echo $post->whDbPass; ?>" size="30"></td>
</tr>
<tr>
	<td colspan="2"><h3><?php echo WH_Lang::_('WH_ADMINACCOUNT',false,'install');?></h3></td>
</tr>
<tr>
	<td><?php echo WH_Lang::_('WH_CHOOSEPASSWORD',false,'install');?>:</td>
	<td><input style="font-family: Courier;" name="whAdminPassword" type="text" value="<?php if ($post->whAdminPassword) { echo $post->whAdminPassword; } else { echo makePass(); } ?>" size="30"></td>
</tr>
<tr>
	<td colspan="2"><h3><?php echo WH_Lang::_('WH_FILESYSTEMCHECK',false,'install');?></h3>
	<p><?php echo WH_Lang::_('WH_FILESYSTEMCHECKSUBDIRS',false,'install');?></p></td>
</tr>
<tr>
	<td colspan="2"><?php if ($_GET["chmod"]=='1') {
		checkDirs(true, true);
	} else { ?>
	<?php $cont = checkDirs(true, false); ?><?php if (!$cont) { ?><br/>
	<a href="javascript:void(null);" onclick="document.installform.action = 'index.php?chmod=1'; document.installform.submit();"><?php echo WH_Lang::_('WH_TRYCHMOD',false,'install'); ?></a>
	<?php }} ?></td>
</tr>
</table>

<?php if ($cont) { ?>
<input type="hidden" name="submitted" value="1">
<input type="submit" value="<?php echo WH_Lang::_('WH_INSTALL',false,'install');?>">
<?php } else { ?>
<p style="color: red;"><?php echo WH_Lang::_('WH_FILESYSTEMERROR',false,'install');?></p>
<input type="hidden" name="submitted" value="0">
<input type="submit" value="<?php echo WH_Lang::_('WH_TRYAGAIN',false,'install');?>">
<?php } ?>
</form>

<?php } 

function makePass($totalChar = 6) {
	$salt = "abcdefghijklmnpqrstuvwxyzABCDEFGHIJKLMNPQRSTUVWXYZ123456789";  // salt to select chars from
	srand((double)microtime()*1000000); // start the random generator
	$password=""; // set the inital variable
	for ($i=0;$i<$totalChar;$i++)  // loop and create password
	            $password = $password . substr ($salt, rand() % strlen($salt), 1);
	return $password;
}

function is__writable($path) {
//will work in despite of Windows ACLs bug
//NOTE: use a trailing slash for folders!!!
//see http://bugs.php.net/bug.php?id=27609
//see http://bugs.php.net/bug.php?id=30931

    if ($path{strlen($path)-1}=='/') // recursively return a temporary file path
        return is__writable($path.uniqid(mt_rand()).'.tmp');
    else if (is_dir($path))
        return is__writable($path.'/'.uniqid(mt_rand()).'.tmp');
    // check tmp file for read/write capabilities
    $rm = file_exists($path);
    $f = @fopen($path, 'a');
    if ($f===false)
        return false;
    fclose($f);
    if (!$rm)
        unlink($path);
    return true;
}
?>

</body></html>