<?php
/**
 * Cambio v0.5a
 * 
 * http://cambiocms.org/
 * @package Cambio
 */
if (defined("CAMBIO") or die("Access error"));

function writeOutput($cacheContent = null, $doCache = true) {
	global $cd, $cf;
	
	$output = "";
	
	/*
	// cache conditions
	$nocache = false;
	if ($cd->uid) {
		$nocache = true;
	}
	if (WH_Helper::get('module') || WH_Helper::get('task')) {
		$nocache = true;
	}
	if (WH_Helper::get("*","post")) {
		$nocache = true;
	}
		
	// retrieve cache
	if (!$nocache) {
		$htmlcache = WH_Cache::getCache("html", $cd->id, "html", "cache/");
	}*/
	
	// write cache or load parser
	if ($cacheContent) {
		$cd->fromcache = true;
		$output = $cacheContent;
	} else {
		$cd->fromcache = false;
		
		if (WH_Helper::get('show')=='module') {
			$moduleid = WH_Helper::get('module');
			if ($moduleid) {
				$output = writeModule(intval($moduleid));
			} else {
				writeError("Module $moduleid not found", true);
			}
		} else {
			
			// loading def template
			include('tmpl/_default/tmpl.php');
			
			// get document tmpl
			global $wh;
			$layout = $wh->layouts->getLayouts($cd->layout);
			$tmpl = $layout->tmpl;
			$layoutname = str_replace(" ","_",$layout->name);
						
			// load document template and run modules
			ob_start();
			if (file_exists('tmpl/'.$tmpl.'/tmpl.php')) {
				include('tmpl/'.$tmpl.'/tmpl.php');
			} else {
				WH_HTML::writeError('Template file not found',false);
			}
			// add template stylesheet and javascript to document
			$tmpljs = 'tmpl/'.$tmpl.'/js/'.$tmpl.'.js';
			$tmplcss = 'tmpl/'.$tmpl.'/css/'.$tmpl.'.css';
			if (file_exists($tmpljs)) {
				$cd->javascript[] = $tmpljs;			
			}
			if (file_exists($tmplcss)) {
				$cd->stylesheets[] = $tmplcss;			
			}
			
			// add layout stylesheet and javascript to document
			$layoutjs = 'tmpl/'.$tmpl.'/js/'.$tmpl.'.'.$layoutname.'.js';
			$layoutcss = 'tmpl/'.$tmpl.'/css/'.$tmpl.'.'.$layoutname.'.css';
			if (file_exists($layoutjs)) {
				$cd->javascript[] = $layoutjs;			
			}
			if (file_exists($layoutcss)) {
				$cd->stylesheets[] = $layoutcss;			
			}
			
			// add style stylesheet
			if (!$cd->style) {
				$stylename = 'default';
			} else {
				$stylename = $cd->style;
			}
			$stylename = str_replace(" ","_",$stylename);
			$stylecss = 'tmpl/'.$tmpl.'/css/'.$tmpl.'.'.$layoutname.'.'.$stylename.'.css';
			if (file_exists($stylecss)) {
				$cd->stylesheets[] = $stylecss;			
			}
			
			$tmplContents = ob_get_contents();
			
			ob_clean();
			
			// load admin modules when logged in
			if ($cd->isa) {
				writeModules('admin');
				$adminContents = ob_get_contents();				
			}
			ob_end_clean();	
			
			// buffer html layou
			$output .= $whDefTmplHeader1."\n";
			$output .= "\t<title>".$cd->htmltitel."</title>"."\n";
		
			// meta tags
			foreach ((array) $cd->meta as $meta) {
				$output .= "\t<meta $meta />"."\n";
			}
			
			// links
			foreach ((array) $cd->links as $link) {
				$output .= "\t<link $link />"."\n";
			}
			
			// stylesheets
			// use WH_Cache
			if ($cf->whUseCompression) {
				$csscache = WH_Cache::getCache("filearray", array_unique($cd->stylesheets), "css", "css/");
				if ($csscache) {
					$output .= "\t<link rel=\"stylesheet\" type=\"text/css\" media=\"screen\" href=\"".$csscache."\" />"."\n";
				}
			} else {
				foreach (array_unique($cd->stylesheets) as $css) {
					$output .= "\t<link rel=\"stylesheet\" type=\"text/css\" media=\"screen\" href=\"".$css."\" />"."\n";
				}
			}
			
			// javascripts
			// use WH_Cache
			if ($cf->whUseCompression) {
				$jscache = WH_Cache::getCache("filearray", array_unique($cd->javascript), "js", "js/");
				if ($jscache) {
					$output .= "\t<script language=\"javascript\" src=\"".$jscache."\" type=\"text/javascript\"></script>"."\n";
				}
			} else {
				foreach (array_unique($cd->javascript) as $js) {
					$output .= "\t<script language=\"javascript\" src=\"".$js."\" type=\"text/javascript\"></script>"."\n";
				}
			}
			
			$output .= $whDefTmplHeader2."\n";
			$output .= $whDefTmplBody1;
			$output .= " onload=\"".implode(";",(array) $cd->onload)."\"";
			// add detection for ESC key
			if ($cd->isa) {
				$output .= " onkeypress=\"return escCheck(event);\"";
			}
			$output .= $whDefTmplBody2."\n";
			
			$output .= $tmplContents;
			$output .= $adminContents;
			
			if (!$cf->whDebug) {
				$output .= "\n".$whDefTmplBody3;
			}
			
			// compress html
			if (!$cf->whDebug) {
				$output = WH_HTML::compress_html($output);	
			}
			
			// saves to cache, except when module has prevented by setting $cd->nocache to true
			if ($doCache && !$cd->nocache) {
				WH_Cache::savePageToCache($output, WH_Cache::makeHTMLCacheId($cd->id, $cd->lang, $cd->style));			
			}
		}
	}
	
	// write buffer	
	echo $output;
}

/**
 * Parse modules for current page with pos
 *
 * @param string $pos
 */
function writePageModules($pos) {
	global $cd, $wh;
	$modules = Array();
	$ordering = Array();
	$titel = Array();
	/* @var $module WH_Module */
	$module = "";
	// add page mods for pos
	foreach ($cd->modules as $k => $module) {
		if ($module->pos == $pos) {
			$modules[] = $module;
		}
	}
	
	// get new for layout
	if (count($modules) == 0) {
		foreach ($cd->layoutitems as $item) {
			if ($item->type == 0) {
				// poscheck
				if ($item->pos == $pos) {
					// add module!
					$moduleid = $wh->modules->getAdminModuleId("modules");
					if ($wh->modules->$moduleid->loadModule(null, true)) {
						WH_Helper::set("module", $item->module, "post");
						WH_Helper::set("pagina", $cd->id, "post");
						WH_Helper::set("pos", $pos, "post");						
						$moduleclass = new WH_AdminModuleModules($wh->modules->$moduleid);
						$moduleclass->editnow = false;
						// catch refresh javascript
						ob_start();
							$newmodid = $moduleclass->save();
						ob_end_clean();
						$modules[] = $wh->modules->_init($newmodid);
					}
					
				}
			}
		}
	}

	// get linked for layout
	foreach ($cd->layoutitems as $item) {
		if ($item->type == 1) {
			// check for replacable
			if ( (count($modules)==0 && $item->replaceable == 1) || $item->replaceable == 0) {
				// poscheck
				if ($wh->modules->{$item->module}->pos == $pos) {
					// huidige modcheck
					$duplicate = false;
					foreach ($modules as $module) {
						if ($module->id == $item->module) {
							$duplicate = true;
						}
					}
					if (!$duplicate) {
						$modules[] = $wh->modules->{$item->module};
					}
				}
			}
		}
	}
	
	// do the order
	foreach ($modules as $key => $row) {
	    $ordering[$key] 	= $row->ordering;
	    $titel[$key] 		= strtolower($row->titel);
	}
	array_multisort($ordering, SORT_ASC, $titel, SORT_ASC, $modules);
	// build sleeplist
	if ($cd->isa) {
		echo "<div id=\"sleepmodule_$pos\" class=\"sleepmodule\">";
		$cd->onload[] = "initSleep('sleepmodule_$pos')";
	}
	// parse the modules
	foreach ($modules as $module) {
		parseModule($module);
	}
	// build sleeplist
	if ($cd->isa) {
		echo "</div>";
	}
}

/**
 * Parse modules for current page with pos
 *
 * @param string $pos
 */
function countPageModules($pos) {
	global $cd;
	/* @var $module WH_Module */
	$module = "";
	$c = 0;
	foreach ($cd->modules as $k => $module) {
		if ($module->pos == $pos) {
			$c++;
		}
	}
	return $c;
}

/**
 * Checks whether module exists for current page with pos
 *
 * @param integer $mid
 * @param string $pos
 */
function hasPageModule($mid, $pos = null) {
	global $cd;
	/* @var $module WH_Module */
	$module = "";
	foreach ($cd->modules as $k => $module) {
		if ($pos) {
			if ($module->pos == $pos) {
				if ($module->id == $mid) {
					return true;
				}
			}
		} else {
			if ($module->id == $mid) {
				return true;
			}
		}
	}
	return false;
}

/**
 * Parse modules with pos, don't bother current page
 *
 * @param string $pos
 */
function writeModules($pos) {
	global $wh;
	/* @var $module WH_Module */
	// convert to array, bug ??
	foreach ((array) $wh->modules as $k => $module) {
		if ($module->pos == $pos) {
			parseModule($module);
		}
	}
}

/**
 * Parse module with id or name, don't bother current page
 *
 * @param mixed $id
 */
function writeModule($id, $delbutton = true) {
	global $wh;
	if (is_integer($id)) {		
		$module = $wh->modules->getModules($id) ;
	} else {
		foreach ($wh->modules as $mod) {
			if ($mod->module == $id) {				
				$module = $mod;
			}
		}
	}
	if (isset($module)) {
		/* @var $module WH_Module */
		parseModule($module, $delbutton);
	} else {
		writeError("Module $id not found");
	}
}

/**
 * Retrieve module and perform task is asked by QueryString
 *
 * @param WH_Module $module
 */
function parseModule($module, $delbutton = true) {
	global $cd;
	if (WH_Helper::get('task') && WH_Helper::get('module') == $module->id) {
		$task = WH_Helper::get('task');
	} else {
		$task = "display";
	}
	if ($module->loadModule()) {
		$className = 'WH_Module'.$module->module;
		$tmp = new $className($module);
		
		if (WH_Helper::get('show')=='module') {
			// execute module, creating output
			$tmp->$task();
		} else {
			// add align class
			if ($module->align) {
				$align = " align_".$module->align;
			}
			// build sleepmodule, niet voor menu en gallery -items
			if ($cd->isa && (strtolower($module->module) == "menu" || strtolower($module->module) == "gallery")) {
				echo "<div class=\"sleepmodule_div\">";
			} elseif ($cd->isa) {
				echo "<li class=\"sleepmodule_li$align\" id=\"sleepmodule_{$module->id}\">";
			}
			// add div to module
			echo "<div class=\"module mod_{$module->module}$align\" id=\"mod_{$module->id}\">";
			// print delete module button when logged in
			if ($module->pos != "admin" && $delbutton) {
				$tmp->buttons[] = Array("deleteModuleButton", $module->id, WH_Lang::_("WH_DELETEMODULE", false)." ".$module->module);
				//echo "<div class=\"knop right\">".WH_HTML::deleteModuleButton($module->id, "Verwijder ".$module->module)."</div>";
			}
			// execute module, creating output
			$tmp->$task();
			// close div
			echo "</div>";
			if ($cd->isa && count($tmp->buttons)>0 && $delbutton) {
				// cmsbar div
				echo "<div class=\"cmsbar\" id=\"cmsbar_{$module->id}\">";
				// print admin buttons
				echo WH_HTML::printAdminButtons($tmp->buttons);
				// close cmsbar div
				echo "</div>";
			}
			// build sleepmodule
			if ($cd->isa && (strtolower($module->module) == "menu" || strtolower($module->module) == "gallery")) {
				echo "</div>";
			} elseif ($cd->isa) {
				echo "</li>";
			}
	
			// add admin stylesheet and javascript to document
			if ($cd->isa) {
				$modjs = 'modules/'.$module->module.'/tmpl/js/'.$module->module.'.admin.js';
				$modcss = 'modules/'.$module->module.'/tmpl/css/'.$module->module.'.admin.css';	
				if (file_exists($modjs)) {
					$cd->javascript[] = $modjs;			
				}
				if (file_exists($modcss)) {
					$cd->stylesheets[] = $modcss;			
				}
			}
			// add stylesheet and javascript to document
			$modjs = 'modules/'.$module->module.'/tmpl/js/'.$module->module.'.js';
			$modcss = 'modules/'.$module->module.'/tmpl/css/'.$module->module.'.css';	
			if (file_exists($modjs)) {
				$cd->javascript[] = $modjs;			
			}
			if (file_exists($modcss)) {
				$cd->stylesheets[] = $modcss;			
			}
			// add custom stylesheet and javascript to document
			$tmpljs = 'tmpl/'.$tmpl.'/modules/'.$module->module.'/js/'.$module->module.'.js';
			$tmplcss = 'tmpl/'.$tmpl.'/modules/'.$module->module.'/css/'.$module->module.'.css';
			if (file_exists($tmpljs)) {
				$cd->javascript[] = $tmpljs;			
			}
			if (file_exists($tmplcss)) {
				$cd->stylesheets[] = $tmplcss;			
			}
		}
	}
}

function writeError($msg, $critical = false) {
	WH_HTML::writeError($msg, $critical);
}


?>