<?php
/**
 * Cambio v0.5a
 * 
 * http://cambiocms.org/
 * @package Cambio
 */
if (defined("CAMBIO") or die("Access error"));

// function to scan dirs (php < 5)
if(!function_exists('scandir')) {
    function scandir($dir, $sortorder = 0) {
        if(is_dir($dir) && $dirlist = @opendir($dir)) {
            while(($file = readdir($dirlist)) !== false) {
                $files[] = $file;
            }
            closedir($dirlist);
            ($sortorder == 0) ? asort($files) : rsort($files); // arsort was replaced with rsort
            return $files;
        } else return false;
    }
}

// look for php files in cms/include directory
$includes = scandir('cms/includes/');
foreach ($includes as $file) {
	if (substr($file,-4,4) == ".php") {
		// load class
		// exeptions
		$name = substr($file,4);
		$name = str_replace('.php','',$name);
		if (!class_exists("WH_".$name)) {
			include_once('cms/includes/'.$file);
		}
	}
}

// get page id
$id = (int) $_GET["id"];

// no id? look in post set default
if (!$id) {
	$id = $cf->whHomepage;
}

// open database
$db = new WH_Database();
if ($db->init($cf->whDatabase, $cf->whDbUser, $cf->whDbPass)==false) {
	WH_HTML::writeError('Kan niet connecten naar database', true);
}
$db->auto_slashes = true;
$db->debug = $cf->whDebug;

// load mainframe properties
$wh = new WH_Mainframe();
$wh->pages = WH_Pages::getInstance();
$wh->modules = WH_Modules::getInstance();
$wh->layouts = WH_Layouts::getInstance();
$wh->cache = WH_Cache::readCacheEntries();

// check whether document exists
if ($wh->pages->getPages($id) == false) {
	// page does not exist
	writeError(WH_Lang::_('Pagina bestaat niet'), true);
}

// hit document
$wh->pages->$id->hit();

// load document properties
$cd = new WH_Document($id);
// get task
$cd->task = $_GET["task"];
// user params
$cd->uid = WH_Helper::get('uid','session');
$cd->tid = WH_Helper::get('tid','session');
$cd->isa = WH_Helper::get('isa','session');
// check whether user exists and hashes are correct
if ($cd->uid) {
	if (!$cd->checkLogin($cd->uid)) {
		// log user out
		session_destroy();
	}
}

// set document language
$cd->setLang();
// set document style
$cd->setStyle();
// page title
$cd->titel = WH_HTML::clean($cd->titel);

// load the parser
writeOutput(null, $cacheCheck);

?>