<?php
/**
 * Cambio v0.5a
 * 
 * http://cambiocms.org/
 * @package Cambio
 */
if (defined("CAMBIO") or die("Access error"));

class WH_ConfigAdvanced extends WH_ConfigDesign {

	// set version
	var $whVersion = "0.5a2";
	
	// set geoip server
	var $whGeoIpServer = "http://geoip.burolaga.nl";
	
	// set session timeout (minutes)
	var $whSessionTimeout = 10;

	function WH_ConfigAdvanced() {
		$this->startSession();
		set_error_handler(array($this, 'process_error_backtrace'));
	}
	
	function startSession() {
		$this->whSessionTimeout = $this->whSessionTimeout * 60;
		ini_set('session.use_only_cookies', 1);
		//$url = "http://".$_SERVER['HTTP_HOST'].dirname($_SERVER['PHP_SELF']);
		//$url = parse_url($url);
		//session_set_cookie_params($cf->whSessionTimeout, $url["path"]."/", null, false, true);
		//session_set_cookie_params($cf->whSessionTimeout, "/", null, false, true);
		session_set_cookie_params($cf->whSessionTimeout);
		session_name("CAMBIOSESSID");
		//setcookie(session_name(), $_COOKIE[session_name()], time()+$cf->whSessionTimeout, "/");
		session_start();
	}
	
	/**
	 * Error handler
	 * see: http://codingforums.com/showthread.php?t=147060
	 */
	function process_error_backtrace($errno, $errstr, $errfile, $errline, $errcontext) {
	    if(!(error_reporting() & $errno)) 
	        return; 
	    switch($errno) { 
	    case E_WARNING      : 
	    case E_USER_WARNING : 
	    case E_STRICT       : 
	    case E_NOTICE       : 
	    case E_USER_NOTICE  : 
	        $type = 'warning'; 
	        $fatal = false; 
	        break; 
	    default             : 
	        $type = 'fatal error'; 
	        $fatal = true; 
	        break; 
	    } 
	    if(php_sapi_name() == 'cli') { 
	        echo 'Backtrace from ' . $type . ' \'' . $errstr . '\' at ' . $errfile . ' <b>' . $errline . '</b>:' . "\n"; 
	        foreach(array_reverse(debug_backtrace()) as $item) 
	            echo '  ' . (isset($item['file']) ? $item['file'] : '<unknown file>') . ' <b>' . (isset($item['line']) ? $item['line'] : '<unknown line>') . '</b> calling ' . $item['function'] . '()' . "\n"; 
	    } else { 
	        echo '<p class="error_backtrace">' . "\n"; 
	        echo '  Backtrace from ' . $type . ' \'' . $errstr . '\' at ' . $errfile . ' <b>' . $errline . '</b>:' . "\n"; 
	        echo '  <ol>' . "\n"; 
	        foreach(array_reverse(debug_backtrace()) as $item) 
	            echo '    <li>' . (isset($item['file']) ? $item['file'] : '<unknown file>') . ' <b>' . (isset($item['line']) ? $item['line'] : '<unknown line>') . '</b> calling ' . $item['function'] . '()</li>' . "\n"; 
	        echo '  </ol>' . "\n"; 
	        echo '</p>' . "\n"; 
	    } 
	    if($fatal) 
     	   exit(1); 
	}
}
?>