// hasClass, addClass and removeClass written by Chris Sullins

function hasClass( element, className ) {
    return element.className.match( '\\b' + className + '\\b' );
}

function addClass( element, className ) {
    if( !element.className.match( '/\\b' + className + '\\b/' ) )
        element.className += ' ' + className;
}

function removeClass( element, className ) {
    element.className = element.className.replace( new RegExp( '\\b' + className + '\\b', 'g' ), '' );
}

function getElementsByCondition(condition,container) { 
	container = container||document 
	var all = container.all||container.getElementsByTagName('*') 
	var arr = [] 
	for(var k=0;k<all.length;k++) { 
		var elm = all[k] 
		if(condition(elm,k)) {
			arr[arr.length] = elm 
		}
	} 
	return arr 
}

// ajax functionality

var ajaxtimer;
var xmlhttp = false;

function admin(xUrl,xForm) {
	showLoader();	
//	hideAdmin();
	include(xUrl,"admincontent",xForm);
}
function include(xUrl,xId,xForm,xParameters) {
	//var xmlhttp = false;
	xmlhttp = false;
	
	/*@cc_on @*/	
	/*@if (@_jscript_version >= 5)
	// JScript gives us Conditional compilation, we can cope with old IE versions.
	// and security blocked creation of the objects.*/
	try {
	xmlhttp = new ActiveXObject("Msxml2.XMLHTTP");
	} catch (e) {
	  try {
	    xmlhttp = new ActiveXObject("Microsoft.XMLHTTP");
	  } catch (E) {
	    xmlhttp = false;
	  }
	}
	/*@end @*/
	if (!xmlhttp && typeof XMLHttpRequest!='undefined') {
		xmlhttp = new XMLHttpRequest();
	}
	if (!xmlhttp) {
		alert("You're using a non-Ajax-capable browser. Please upgrade!");
		return false;
	}
	if (xForm) {
		xmlhttp.open('POST', xUrl, true);
		xParameters = getParameters(xForm);
		xmlhttp.setRequestHeader("Content-type", "application/x-www-form-urlencoded; charset=utf-8");
		xmlhttp.setRequestHeader("Content-length", xParameters.length);
		xmlhttp.setRequestHeader("Connection", "close");
	} else {
		if (xParameters) {
			xmlhttp.open("POST", xUrl, true);
			xmlhttp.setRequestHeader("Content-type", "application/x-www-form-urlencoded; charset=utf-8");
			xmlhttp.setRequestHeader("Content-length", xParameters.length);
			xmlhttp.setRequestHeader("Connection", "close");
		} else {
			xmlhttp.open("GET", xUrl,true);
			xParameters = null;
		}
	}
	// don't clear node
	//document.getElementById(xId).innerHTML = '';
	xmlhttp.onreadystatechange=function() {
		if (xmlhttp.readyState==4) {
			if (xmlhttp.status == 0) {			
			} else if (xmlhttp.status == 200) {
				if (xId == 'admincontent') {
					hideLoader();
					showAdmin();				
				}
				resp=xmlhttp.responseText;
		    	document.getElementById(xId).innerHTML = resp;
	    		launchJavascript(resp);
			} else {
				alert("I'm sorry to inform you that the AJAX request failed with the following status code: "+ xmlhttp.status);
			}
			clearTimeout(ajaxtimer);
		}
	}
	xmlhttp.send(xParameters);
	ajaxtimer = setTimeout("ajaxtime()", 5000)
}

function ajaxtime() {
	$("#ajaxtime").show();
	$("#ajaxtimelink").bind( "click", function() { ajaxCancel(); });
}

function ajaxCancel() {
	hideLoader();
	xmlhttp.abort();
}

function getParameters(obj) {
	var poststr = '';
	for (i=0;i<obj.length;i++) {
		if (obj[i].name) {
			switch(obj[i].type) {
				case "checkbox":
					poststr = poststr + obj[i].name + "=" + escape(encodeURIComponent(obj[i].checked)) + "&";
					break;
				case "radio":
					if (obj[i].checked) {
						poststr = poststr + obj[i].name + "=" + escape(encodeURIComponent(obj[i].value)) + "&";
					}
					break;
				case "select-multiple":
					for (p=0;p<obj[i].options.length;p++) {
						if (obj[i].options[p].selected) {
							poststr = poststr + obj[i].name + "=" + escape(encodeURIComponent(obj[i].options[p].value)) + "&";
						}
					}
					break;
				default:
					poststr = poststr + obj[i].name + "=" + escape(encodeURIComponent(obj[i].value)) + "&";
					//if (obj[i].name=="taal") { alert(obj[i].value); }
					//poststr = poststr + obj[i].name + "=" + encodeURI(obj[i].value) + "&";
					//poststr = poststr + obj[i].name + "=" + escape(obj[i].value) + "&";
					//poststr = poststr + obj[i].name + "=" + encodeURIComponent(obj[i].value) + "&";
			}					
		}
	}
	poststr = poststr.substr(0,poststr.length-1);
	return poststr;
}
function launchJavascript(responseText) {
	// RegExp from prototype.sonio.net
	var ScriptFragment = '(?:<script.*?>)((\n|.)*?)(?:</script>)';
	
	var match    = new RegExp(ScriptFragment, 'img');
	var scripts  = responseText.match(match);
	
	if(scripts) {
		var js = '';
		for(var s = 0; s < scripts.length; s++) {
		    var match = new RegExp(ScriptFragment, 'im');
		    js += scripts[s].match(match)[1];
		}
		eval(js);
	}
}

function initAdmin() {
	sizeAdmin();
}
function sizeAdmin() {
	var frameHeight, frameWidth, aHeight, aWidth;
	if (self.innerWidth) {
		frameWidth = self.innerWidth;
		frameHeight = self.innerHeight;
		pos = window.pageYOffset;
	} else if (document.documentElement && document.documentElement.clientWidth) {
		frameWidth = document.documentElement.clientWidth;
		frameHeight = document.documentElement.clientHeight;
		pos = document.documentElement.scrollTop;
	} else if (document.body) {
		frameWidth = document.body.clientWidth;
		frameHeight = document.body.clientHeight;
		pos = document.body.scrollTop;
	}
	aHeight = 600;
	aWidth = 800;
	if (frameHeight-50<600) {
		aHeight = frameHeight-50;
	}
	if (frameWidth-50<800) {
		aWidth = frameWidth-50;
	}
	document.getElementById('admin_ph').style.width = frameWidth + 'px';
	document.getElementById('admin_ph').style.height = frameHeight + 'px';
	document.getElementById('admin_ph').style.top = pos + 'px';
	
	document.getElementById('admin_loader').style.width = frameWidth + 'px';
	document.getElementById('admin_loader').style.height = frameHeight + 'px';
	document.getElementById('admin_loader').style.top = pos + 'px';
	
	document.getElementById('admin').style.top= pos + (frameHeight/2) - (aHeight/2) + 'px';
	document.getElementById('admin').style.left=(frameWidth/2)-(aWidth/2) + 'px';
	document.getElementById('admin').style.height= aHeight+'px';
	document.getElementById('admin').style.width= aWidth+'px' ;
}
function showAdmin() {
	if (document.getElementById('admin')) {
		document.getElementById('admin').style.display = 'block';	
		document.getElementById('admin_ph').style.display = 'block';		
		var hidden = getElementsByCondition( 
			function(el){
				if(el.className=='module mod_pages') {
					el.style.display="none";
				}
			}
		);
		setSizeAdmin();
		sizeAdmin();
	}
}
function hideAdmin() {
	if (document.getElementById('admin')) {
		document.getElementById('admin').style.display = 'none';
		document.getElementById('admin_ph').style.display = 'none';
		var hidden = getElementsByCondition( 
			function(el){
				if(el.className=='module mod_pages') {
					el.style.display = "block";
				}
			}
		);
	}
	noSizeAdmin();
}

function setSizeAdmin() {
	window.onresize = sizeAdmin;
	window.onscroll = sizeAdmin;
}

function noSizeAdmin() {
	window.onresize = null;
	window.onscroll = null;
}

function showLoader() {
	if (document.getElementById('admin_ph').style.display == 'block') {
		document.getElementById('admin_ph').style.display = 'none';
	}
	$("#ajaxtime").hide();
	$("#admin_loader").show();
	setSizeAdmin();
	sizeAdmin();
}

function hideLoader() {
	if (document.getElementById('admin_ph').style.display == 'none') {
		document.getElementById('admin_ph').style.display = 'block';
	}
	$("#admin_loader").hide();
	noSizeAdmin();
}

function escCheck(event) {
	if(event.keyCode==27) {
		hideAdmin();
	}
}