<?php
/**
 * Cambio v0.5a
 *
 * http://cambiocms.org/
 * @package Cambio
 */
if (defined("CAMBIO") or die("Access error"));

class WH_AdminModuleDynamicData extends WH_AdminModuleDynamic {
	
	var $typeid;
	var $filter;
	
	var $type;
	var $fields;
	
	var $datatable;	
	var $options;

	function WH_ModuleDynamicData($data) {
		$this->_init($data);
		// workaround to set module id when loaded as an admin section module
		if (empty($this->id)) {
			global $wh;
			$this->id = $wh->modules->getAdminModuleId($this->module);
			if (empty($this->id)) {
				global $cd;
				WH_HTML::writeError("No dynamic admin module found.", true);
			}
		}
	}

	function display() {
		global $db;
		$db->select("SELECT * FROM mod_dyn");
		$this->sections = $db->get_obj();

		foreach ($this->sections as &$section) {
			$db->select("SELECT * FROM mod_dyn_type WHERE dynid = $section->id");
			$section->types = $db->get_obj();
		}

		$this->render("default");
	}
	
	function _initType() {
		global $db;
		$db->select("SELECT * FROM mod_dyn_type INNER JOIN mod_dyn ON mod_dyn.id = mod_dyn_type.dynid WHERE mod_dyn_type.id = $this->typeid");
		return $this->type = (object) $db->get_row();
	}
	
	function _initDatatable() {
		return $this->datatable = $this->_filterdbname("mod_dyn_data_".$this->type->dyn_name."_".$this->type->type_name);
	}
	
	function _initFields() {
		global $db;
		$db->select("SELECT * FROM mod_dyn_field WHERE typeid = $this->typeid");
		return $this->fields = $db->get_obj();
	}
	
	function _initData($id = false) {
		global $db;
		$linkedvalues = array();
		if ($id !== false) {
			$db->select("SELECT * FROM $this->datatable WHERE id = $id");
			return $this->data = (object) $db->get_row();
		} else {
			if ($this->filter) {
				$this->filter = str_replace(",", " ", $this->filter);
				$this->filter = str_replace("  ", " ", $this->filter);
				$this->filter = explode(" ", addslashes($this->filter));
				$where = array();
				foreach($this->fields as $field) {
					switch ($field->field_type) {
						case "text":
							$where[] = $field->field_name . " LIKE '%" . implode("%' AND $field->field_name LIKE '%", $this->filter) . "%'";
							break;
						case "numeric":
							$where[] = $field->field_name . " = " . implode(" AND $field->field_name = ", $this->filter);
							break;
					}
				}
				$where = "(" . implode(") OR (", $where) . ")";
			} else {
				$where = "1";
			}
			$db->select("SELECT * FROM $this->datatable WHERE $where");
			$this->data = $db->get_obj();
			foreach ($this->data as $row) {
				foreach($row as $key => &$value) {
					if (in_array($this->options["columns"][$key]["type"], array("linked"))) {
						if (isset($linkedvalues[$value])) {
							$value = $linkedvalues[$value];
						} else {
							$newval = $db->select_one("SELECT ".
								$this->options["columns"][$key]["parent"]["show"]." FROM ".
								$this->options["columns"][$key]["parent"]["table"]." WHERE id = $value");
							$linkedvalues[$value] = $newval;
							$value = $newval; 
						}
					}
				}
			}
			return $this->data;
		}
	}
	
	function _initOptions() {
		$this->options = $this->_getoptions($this->fields);
		$this->options["title"] = $this->type->type_name;
	}
	
	function _initAll($id = false) {
		$this->_initType();
		$this->_initDatatable();
		$this->_initFields();
		$this->_initOptions();
		$this->_initData($id);
	}
	
	function ajaxtable() {
		$this->ajax = true;
		$this->table();
	}
	
	function table() {
		$this->typeid = WH_Helper::get("typeid");	
		$this->filter = WH_Helper::get("filter");	
		$this->_initAll(false);		
				
		// iterate rows
		foreach ($this->data as $row) {
			$row->_edit = WH_HTML::adminLink($this->id, "data_edit", $row->id, WH_Lang::_("WHADMIN_EDIT",false,"static"), false, "find", "typeid=$this->typeid");
			$row->_delete = WH_HTML::adminLink($this->id, "data_deleteitem", $row->id, WH_Lang::_("WHADMIN_DELETE",false,"static"), true, "note_delete", "typeid=$this->typeid");
		}
		
		// prerender data
		$this->_prerender($this->data, $this->options);

		// create table
		$table = new WH_HTML_Table($this->data);
				
		// headers
		$headers = array();
		foreach ($this->options["columns"] as $column => $values) {
			if (!empty($values["title"])) {
				$headers[$column] = $values["title"];
			}
		}
		$headers["_edit"] = "";
		$headers["_delete"] = "";
		$table->setHeaders($headers);

		$table->setDisplayColumns(array_keys($headers));
		
		$this->table = &$table;
		$this->title = $this->options["title"];

		// render
		if ($this->ajax) {
			$this->table->render();
		} else {
			$this->render("table");
		}
	}
	
	function add() {
		$this->typeid = WH_Helper::get("typeid");		
		$this->_initAll(false);
		$id = WH_Helper::get("elmid");
			
		$dbe = new WH_DBEditor();	
		$this->res = $dbe->detail($this->datatable, WH_DBEditor::MODE_ADD, $this->options, null, $this->id, "data_save", "data_table", null, "typeid=$this->typeid");
		$this->title = $this->options["title"];
		
		$this->render("edit");
	}
	
	function edit() {
		$this->typeid = WH_Helper::get("typeid");		
		$this->_initAll(false);
		$id = WH_Helper::get("elmid");

		$where = "id = $id";
		
		$dbe = new WH_DBEditor();
		$this->res = $dbe->detail($this->datatable, WH_DBEditor::MODE_EDIT, $this->options, $where, $this->id, "data_save", "data_table", null, "typeid=$this->typeid");
		$this->title = $this->options["title"];
		
		$this->render();
	}
			
	function save() {
		$this->typeid = WH_Helper::get("typeid");	
		$this->_initType();
		$this->_initDatatable();

		$dbe = new WH_DBEditor();
		$post = WH_Helper::get("*", "post");
		if (!empty($_POST["id"])) {
			$dbe->updateTable($this->datatable, $post, "id = ".$post["id"]);
		} else {
			$dbe->addToTable($this->datatable, $post);
		}
		global $db;
		WH_Helper::set("elmid", $this->typeid);
		$this->table();
	}
	
	function deleteitem() {
		$this->typeid = WH_Helper::get("typeid");	
		$this->_initType();
		$this->_initDatatable();
		
		$id = WH_Helper::get("elmid");
			
		$dbe = new WH_DBEditor();	
		$dbe->delete($this->datatable, "id = $id");
		
		$this->display();
	}

	function _getoptions($fields) {
		global $db;
		$options = Array();
		$options["columns"]["id"]["title"] = "ID";
		foreach ($fields as $field) {
			$options["columns"][$field->field_name]["title"] = $field->field_caption;
			switch ($field->field_type) {
				case "text":
					if ($field->field_maxlen) {
						$options["columns"][$field->field_name]["type"] = "string";
					} else {
						$options["columns"][$field->field_name]["type"] = "text";
					}
					break;
				case "linked":
					$options["columns"][$field->field_name]["type"] = $field->field_type;
					$options["columns"][$field->field_name]["parent"] = array();
					$options["columns"][$field->field_name]["parent"]["table"] = $this->getDataTableName($field->field_linkedto);
					$options["columns"][$field->field_name]["parent"]["link"] = "id";
					$options["columns"][$field->field_name]["parent"]["show"] = $db->select_one("SELECT field_name FROM mod_dyn_field WHERE id = ".$field->field_linkedshow);
//					$options["columns"][$field->field_name]["parent"]["where"] = "typeid = $field_linkedto";
//					$options["columns"][$field->field_name]["parent"]["selected"] = null;
					break;
				default:
					$options["columns"][$field->field_name]["type"] = $field->field_type;
					break;
			}
		}
		return $options;
	}

	function _prerender(&$data, $options) {
		$maxcollength = 15;
		foreach($data as &$row) {			
			foreach($row as $key => &$column) {
				if ($options["columns"][$key]["type"] == "text") {					
					$column = substr($column, 0, $maxcollength).((strlen($column) > $maxcollength) ? "..." : "");
				}
			}
		}
	}

}
?>