<?php
/**
 * Cambio v0.5a
 * 
 * http://cambiocms.org/
 * @package Cambio
 */
if (defined("CAMBIO") or die("Access error"));

class WH_AdminModuleDynamicField extends WH_AdminModuleDynamic {

	function WH_ModuleDynamicField($data) {
		$this->_init($data);
		// workaround to set module id when loaded as an admin section module
		if (empty($this->id)) {
			global $wh;
			$this->id = $wh->modules->getAdminModuleId($this->module);	
			if (empty($this->id)) {	
				global $cd;
				WH_HTML::writeError("No dynamic admin module found.", true);
			}
		}
	}	
	
	function _getoptions($id = null) {
		$options = Array();
		
		$options["title"] = WH_Lang::_("WHADMIN_EDITFIELD");
				
		$options["columns"]["id"]["title"] = "ID";
		
		$options["columns"]["field_name"]["title"] = WH_Lang::_("WHADMIN_FIELDNAME");
		
		$options["columns"]["field_type"]["title"] = WH_Lang::_("WHADMIN_FIELDTYPE");
		$options["columns"]["field_type"]["type"] = "list";
		$options["columns"]["field_type"]["list"] = array(
			"text" => WH_Lang::_("WHADMIN_TEXTTYPE"),
			"numeric" => WH_Lang::_("WHADMIN_NUMERICTYPE"),
			"date" => WH_Lang::_("WHADMIN_DATETYPE"),
			"linked" => WH_Lang::_("WHADMIN_LINKEDTYPE")
		);
		
		$options["columns"]["field_caption"]["title"] = WH_Lang::_("WHADMIN_FIELDCAPTION");
		
		$options["columns"]["field_maxlen"]["title"] = WH_Lang::_("WHADMIN_FIELDMAXLEN");
		
		$options["columns"]["field_required"]["title"] = WH_Lang::_("WHADMIN_FIELDREQUIRED");
			
		$options["columns"]["field_linkedto"]["title"] = WH_Lang::_("WHADMIN_FIELDLINKEDTO");
		$options["columns"]["field_linkedto"]["type"] = "linked";
		$options["columns"]["field_linkedto"]["parent"] = array();
		$options["columns"]["field_linkedto"]["parent"]["table"] = "mod_dyn_type";
		$options["columns"]["field_linkedto"]["parent"]["link"] = "id";
		$options["columns"]["field_linkedto"]["parent"]["show"] = "type_name";
		$options["columns"]["field_linkedto"]["parent"]["where"] = null;
		$options["columns"]["field_linkedto"]["parent"]["selected"] = null;
		
		$options["columns"]["field_linkedshow"]["title"] = WH_Lang::_("WHADMIN_FIELDLINKEDSHOW");
		global $db;
		$field_linkedto = $db->select_one("SELECT field_linkedto FROM mod_dyn_field WHERE id = $id");
		if ($field_linkedto && $id) {
			$options["columns"]["field_linkedshow"]["type"] = "linked";
			$options["columns"]["field_linkedshow"]["parent"] = array();
			$options["columns"]["field_linkedshow"]["parent"]["table"] = "mod_dyn_field";
			$options["columns"]["field_linkedshow"]["parent"]["link"] = "id";
			$options["columns"]["field_linkedshow"]["parent"]["show"] = "field_caption";
			$options["columns"]["field_linkedshow"]["parent"]["where"] = "typeid = $field_linkedto";
			$options["columns"]["field_linkedshow"]["parent"]["selected"] = null;		
		} else {
			$options["columns"]["field_linkedshow"]["type"] = "list";
			$options["columns"]["field_linkedshow"]["list"] = array("" => WH_Lang::_("WHADMIN_CHOOSELINKEDTOFIRST"));	
		}
		
		$options["columns"]["typeid"]["title"] = WH_Lang::_("WHADMIN_TYPE");
		$options["columns"]["typeid"]["type"] = "linked";
		$options["columns"]["typeid"]["parent"] = array();
		$options["columns"]["typeid"]["parent"]["table"] = "mod_dyn_type";
		$options["columns"]["typeid"]["parent"]["link"] = "id";
		$options["columns"]["typeid"]["parent"]["show"] = "type_name";
		$options["columns"]["typeid"]["parent"]["where"] = null;
		$options["columns"]["typeid"]["parent"]["selected"] = null;
		
		return $options;
	}	
	
	function display() {
		global $db;
		
		$db->select("SELECT type_name FROM mod_dyn_type ORDER BY type_name ASC");
		$this->filterlist = $db->get_array();

		$this->filter = WH_Helper::get("filter", "get"); 
		if (!empty($this->filter)) {
			$where = " WHERE t.id = $this->filter";
		}
				
		$db->select("
			SELECT
				f.*, t.id as typeid, t.type_name as type_name
			FROM
				mod_dyn_field f
			INNER JOIN
				mod_dyn_type t ON f.typeid = t.id$where");
		$data = $db->get_obj();
		
		// iterate rows
		foreach ($data as $row) {
			$row->field_caption = WH_HTML::adminLink($this->id, "field_edit", $row->id, $row->field_caption);
			$row->delete = WH_HTML::adminLink($this->id, "field_deleteitem", $row->id, WH_Lang::_("WHADMIN_DELETE",false,"static"), true, "note_delete");
		}
		
		// create table
		$table = new WH_HTML_Table($data);
		
		// headers
		$options = $this->_getoptions();
		$headers = array();
		foreach ($options["columns"] as $column => $values) {
			if (!empty($values["title"])) { 
				$headers[$column] = $values["title"];
			}
		}
		$headers["delete"] = "";
		$table->setHeaders($headers);
		
		$table->setDisplayColumns(array("id","field_caption","field_type","delete"));
		
		// pass table
		$this->table = &$table;
		
		// filter
		$db->select("SELECT id, type_name FROM mod_dyn_type ORDER BY type_name");
		$this->types = $db->get_obj();
		
		// render
		$this->render("default");
	}	
	
	function add() {
		$options = $this->_getoptions();	
		
		$dbe = new WH_DBEditor();	
		$this->res = $dbe->detail("mod_dyn_field", 2, $options, null, $this->id, "field_save", "field_display");
		
		$this->render("edit");
	}
	
	function edit() {
		$id = WH_Helper::get("elmid");
		$where = "id = $id";
		$options = $this->_getoptions($id);	
		
		$dbe = new WH_DBEditor();
		$this->res = $dbe->detail("mod_dyn_field", 1, $options, $where, $this->id, "field_save", "field_display", "typeid");
		
		$this->render();
	}
			
	function save() {
		$dbe = new WH_DBEditor();
		$post = WH_Helper::get("*", "post");
		if (!empty($_POST["id"])) {
			$dbe->updateTable("mod_dyn_field", $post, "id = ".$post["id"]);
		} else {
			$dbe->addToTable("mod_dyn_field", $post);
		}
		$this->display();
	}
	
	function deleteitem() {
		$id = WH_Helper::get("elmid");
			
		$dbe = new WH_DBEditor();	
		$dbe->delete("mod_dyn_field", "id = $id");
		
		$this->display();
	}
	
}
?>