<?php
/**
 * Cambio v0.5a
 * 
 * http://cambiocms.org/
 * @package Cambio
 */
if (defined("CAMBIO") or die("Access error"));

class WH_AdminModuleDynamicSection extends WH_AdminModuleDynamic {

	function WH_ModuleDynamicSection($data) {
		$this->_init($data);
		// workaround to set module id when loaded as an admin section module
		if (empty($this->id)) {
			global $wh;
			$this->id = $wh->modules->getAdminModuleId($this->module);	
			if (empty($this->id)) {	
				global $cd;
				WH_HTML::writeError("No dynamic admin module found.", true);
			}
		}		
	}
	
	function _getoptions() {
		$options = Array();
		
		$options["title"] = WH_Lang::_("WHADMIN_EDITSECTION");
				
		$options["columns"]["id"]["title"] = "ID";
		$options["columns"]["id"]["type"] = "numeric";
		
		$options["columns"]["dyn_name"]["title"] = WH_Lang::_("SECTIONNAME");
		$options["columns"]["dyn_name"]["type"] = "text";
		
		return $options;
	}	
	
	function display() {
		global $db;
		$db->select("SELECT * FROM mod_dyn");
		$data = $db->get_obj();
		
		// iterate rows
		foreach ($data as $row) {
			$row->dyn_name = WH_HTML::adminLink($this->id, "section_edit", $row->id, $row->dyn_name);
			$row->types = WH_HTML::adminLink($this->id, "type_display", null, "Types", false, "forward", "filter=".$row->id);
			$row->update = WH_HTML::adminLink($this->id, "section_updatedb", $row->id, "Update DB", true, "database");
			$row->delete = WH_HTML::adminLink($this->id, "section_deleteitem", $row->id, "Delete", true, "note_delete");
		}
		
		// create table
		$table = new WH_HTML_Table($data);
		
		// headers
		$options = $this->_getoptions();
		$headers = array();
		foreach ($options["columns"] as $column => $values) {
			if (!empty($values["title"])) { 
				$headers[$column] = $values["title"];
			}
		}
		$headers["delete"] = "";
		$headers["types"] = "";
		$headers["update"] = "";
		$table->setHeaders($headers);
		
		// pass table
		$this->table = &$table;
		
		// render
		$this->render("default");
	}	
	
	function add() {
		$options = $this->_getoptions();	
		
		$dbe = new WH_DBEditor();	
		$this->res = $dbe->detail("mod_dyn", 2, $options, null, $this->id, "section_save", "section_display");
		
		$this->render("edit");
	}
	
	function edit() {
		$id = WH_Helper::get("elmid");
		$where = "id = $id";
		$options = $this->_getoptions();	
		
		$dbe = new WH_DBEditor();
		$this->res = $dbe->detail("mod_dyn", 1, $options, $where, $this->id, "section_save", "section_display");
		
		$this->render();
	}
			
	function save() {
		$dbe = new WH_DBEditor();
		$post = WH_Helper::get("*", "post");
		if (!empty($_POST["id"])) {
			$dbe->updateTable("mod_dyn", $post, "id = ".$post["id"]);
		} else {
			$dbe->addToTable("mod_dyn", $post);
		}
		$this->display();
	}
	
	function deleteitem() {
		$id = WH_Helper::get("elmid");
			
		$dbe = new WH_DBEditor();
		if ($dbe->hasChildren("section", $id)) {
			WH_HTML::adminWarning("This section has record types, please delete them first.");
		} else {
			$dbe->delete("mod_dyn", "id = $id");
		}
		
		$this->display();
	}
	
	function updatedb() {
		global $db;
		
		$id = WH_Helper::get("elmid");
		$sectionname = $db->select_one("SELECT dyn_name FROM mod_dyn WHERE id = $id");
		$db->select("SELECT * FROM mod_dyn_type WHERE dynid = $id");
		$types = $db->get_obj();
		$this->sql = array();
		
		foreach ($types as $type) {
			$tablename = $this->_filterdbname("mod_dyn_data_".$sectionname."_".$type->type_name);
			$db->select("SELECT * FROM mod_dyn_field WHERE typeid = $type->id");
			$fields = $db->get_obj();
			$sql = "DROP TABLE IF EXISTS `$tablename`;\r\n";
			$sql .= "CREATE TABLE `$tablename` (".
				"`id` int(11) NOT NULL auto_increment,";
			foreach ($fields as $field) {
				switch ($field->field_type) {
					case "text":
						if ($field->field_maxlen > 0) { 
							$type = "VARCHAR($field->field_maxlen)";	
						} else {
							$type = "TEXT";
						}
						break;
					case "numeric":
						$type = "INT(11)";
						break;
					case "date":
						$type = "DATETIME";
						break;
				}
				if ($field->field_required) {
					$null = "NOT NULL";
				} else {
					$null = "NULL";
				}
				$fieldname = $this->_filterdbname($field->field_name);
				$sql .= " `$fieldname` $type $null, ";
			}
			$sql = substr($sql, 0, -2);
  			$sql .= ", PRIMARY KEY  (`id`) ".
				") ENGINE=MyISAM AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;";
			$this->sql[] = $sql;
		}
		
		$this->sql = implode("\r\n\r\n",$this->sql);
		
		$this->render();
	}
	
}
?>