<?php
/**
 * Cambio v0.5a
 * 
 * http://cambiocms.org/
 * @package Cambio
 */
if (defined("CAMBIO") or die("Access error"));

class WH_AdminModuleDynamicType extends WH_AdminModuleDynamic {

	function WH_ModuleDynamicType($data) {
		$this->_init($data);
		// workaround to set module id when loaded as an admin section module
		if (empty($this->id)) {
			global $wh;
			$this->id = $wh->modules->getAdminModuleId($this->module);	
			if (empty($this->id)) {	
				global $cd;
				WH_HTML::writeError("No dynamic admin module found.", true);
			}
		}
	}
	
	function _getoptions() {
		$options = Array();
		
		$options["title"] = WH_Lang::_("WHADMIN_EDITTYPE");
				
		$options["columns"]["id"]["title"] = "ID";
		$options["columns"]["id"]["type"] = "numeric";
		
		$options["columns"]["type_name"]["title"] = WH_Lang::_("WHADMIN_TYPENAME");
		$options["columns"]["type_name"]["type"] = "string";
		
		$options["columns"]["dynid"]["title"] = WH_Lang::_("WHADMIN_SECTION");
		$options["columns"]["dynid"]["type"] = "linked";
		$options["columns"]["dynid"]["parent"] = array();
		$options["columns"]["dynid"]["parent"]["table"] = "mod_dyn";
		$options["columns"]["dynid"]["parent"]["link"] = "id";
		$options["columns"]["dynid"]["parent"]["show"] = "dyn_name";
		$options["columns"]["dynid"]["parent"]["where"] = null;
		$options["columns"]["dynid"]["parent"]["selected"] = null;
		
		return $options;
	}	
	
	function display() {
		global $db;
		
		$db->select("SELECT dyn_name FROM mod_dyn ORDER BY dyn_name ASC");
		$this->filterlist = $db->get_array();

		$this->filter = WH_Helper::get("filter", "get"); 
		if (!empty($this->filter)) {
			$where = " WHERE d.id = $this->filter";
		}
				
		$db->select("SELECT t.id as id, d.dyn_name as dynid, t.type_name as type_name FROM mod_dyn_type t INNER JOIN mod_dyn d ON t.dynid = d.id$where");
		$data = $db->get_obj();
		
		// iterate rows
		foreach ($data as $row) {
			$row->type_name = WH_HTML::adminLink($this->id, "type_edit", $row->id, $row->type_name);
			$row->fields = WH_HTML::adminLink($this->id, "field_display", null, "Fields", false, "forward", "filter=".$row->id);
			$row->delete = WH_HTML::adminLink($this->id, "type_deleteitem", $row->id, "Delete", true, "note_delete");
		}
		
		// create table
		$table = new WH_HTML_Table($data);
		
		// headers
		$options = $this->_getoptions();
		$headers = array();
		foreach ($options["columns"] as $column => $values) {
			if (!empty($values["title"])) { 
				$headers[$column] = $values["title"];
			}
		}
		$headers["delete"] = "";
		$table->setHeaders($headers);
		
		// pass table
		$this->table = &$table;
		
		// filter
		$db->select("SELECT * FROM mod_dyn ORDER BY dyn_name");
		$this->sections = $db->get_obj();
		
		// render
		$this->render("default");
	}	
	
	function add() {
		$options = $this->_getoptions();	
		
		$dbe = new WH_DBEditor();	
		$this->res = $dbe->detail("mod_dyn_type", 2, $options, null, $this->id, "type_save", "type_display", "dynid");
		
		$this->render("edit");
	}
	
	function edit() {
		$id = WH_Helper::get("elmid");
		$where = "id = $id";
		$options = $this->_getoptions();	
		
		$dbe = new WH_DBEditor();
		$this->res = $dbe->detail("mod_dyn_type", 1, $options, $where, $this->id, "type_save", "type_display", "dynid");
		
		$this->render();
	}
			
	function save() {
		$dbe = new WH_DBEditor();
		$post = WH_Helper::get("*", "post");
		if (!empty($_POST["id"])) {
			$dbe->updateTable("mod_dyn_type", $post, "id = ".$post["id"]);
		} else {
			$dbe->addToTable("mod_dyn_type", $post);
		}
		$this->display();
	}
	
	function deleteitem() {
		$id = WH_Helper::get("elmid");
			
		$dbe = new WH_DBEditor();
		if ($dbe->hasChildren("section", $id)) {
			WH_HTML::adminWarning("This record type has fields, please delete them first.");
		} else {
			$dbe->delete("mod_dyn_type", "id = $id");
		}	
		
		$this->display();
	}
	
}
?>