<?php
/**
 * Cambio v0.5a
 * 
 * http://cambiocms.org/
 * @package Cambio
 */
if (defined("CAMBIO") or die("Access error"));

class WH_ModuleEmail extends WH_Module {
	
	function display() {
		global $db, $cd;
		
		$this->result = $this->retrieveLangQuery("SELECT * FROM mod_email WHERE module = $this->id", $cd->lang, "velden");

		if ($cd->lang != $this->result->lang && !empty($this->result->velden)) {
			$this->msg .= WH_HTML::noLangMarker($this->result->lang);
		}
		
		if (!$this->result->velden) {
			$this->result->velden = Array(WH_Lang::_("WH_NEWFORM", false));
			$this->result->req = "0";
		} else {
			// fieldnames
			$this->result->velden = explode(",",$this->result->velden);
			// trim
			for ($i=0;$i<count($this->result->velden);$i++) {
				$this->result->velden[$i] = trim($this->result->velden[$i]);
			}
			
			// field descriptions
			$this->result->captions = explode(",",$this->result->captions);
			// trim
			for ($i=0;$i<count($this->result->captions);$i++) {
				$this->result->captions[$i] = trim($this->result->captions[$i]);
			}
			
			// types
			$this->result->types = explode(",",$this->result->types);
			// trim
			for ($i=0;$i<count($this->result->types);$i++) {
				$this->result->types[$i] = trim($this->result->types[$i]);
			}
		}
		
		$cd->javascript[] = "modules/admin/tmpl/js/ajax.admin.js";	
		
		$this->render();
	}
	
	function send() {
		
		// form not send
		$this->formsent = false;
		
		// load database
		$this->result = $this->retrieveLangQuery("SELECT * FROM mod_email WHERE module = $this->id", $cd->lang, "velden");
		
		// read post data
		$this->post = (object) WH_Helper::get("*", "post");
		
		// does module exist?
		if ($this->result->velden) {
			
			// fieldnames
			$this->result->velden = explode(",",$this->result->velden);
			// trim
			for ($i=0;$i<count($this->result->velden);$i++) {
				$this->result->velden[$i] = trim($this->result->velden[$i]);
				if (strtolower($this->result->velden[$i]) == 'email') {
					$this->result->velden[$i] = "email";
				} 
			}
			
			// field descriptions
			$this->result->captions = explode(",",$this->result->captions);
			// trim
			for ($i=0;$i<count($this->result->captions);$i++) {
				$this->result->captions[$i] = trim($this->result->captions[$i]);
			}
			
			// all required fields filled in?
			$formready = true;
			$validemail = true;
			
			// set error fields
			$this->errorfields = Array();
			
			// required
			for ($i=0;$i<count($this->result->velden);$i++) {
				if (substr($this->result->req,$i,1)==1) {
					if (!$this->post->{$this->result->velden[$i]}) {
						$this->errorfields[] = $this->result->velden[$i];
						$formready = false;
					}
				}
			}
			
			// valid e-mail
			if ($formready && in_array("email",$this->result->velden)) {
				$validemail = $this->check_email_address($this->post->email);
			}
			
			if ($formready && $validemail) {
			
				// create mail class
				$formmail = new WH_Mail();	
				
				// set class to use PHP mail function		
				$formmail->IsMail();
				
				// set from mail address
				if ((!in_array("email",$this->result->velden) && !in_array("Email",$this->result->velden)) && $this->result->emailfrom) {
					$formmail->From = $this->result->emailfrom;
				} elseif ($this->post->email) {
					$formmail->From = $this->post->email;
				} elseif ($this->post->Email) {
					$formmail->From = $this->post->Email;
				} else {
					// no from field found!!
				}
				
				// to address
				$formmail->AddAddress($this->result->emailto);
				
				// subject
				$formmail->Subject = $this->result->titel;
				
				// make body
				for ($i=0;$i<count($this->result->velden);$i++) {
					if ($this->result->captions[$i]) {
						$formmail->Body .= $this->result->captions[$i] . ": " . $this->post->{$this->result->velden[$i]} . "\r\n";
					} else {
						$formmail->Body .= $this->result->velden[$i] . ": " . $this->post->{$this->result->velden[$i]} . "\r\n";
					}		
				}			
				
				// send form!
				if ($formmail->Send()) {
					$this->formsent = true;
					$this->msg = WH_Lang::_('WH_FORMSENT', false);
				} else {
					$this->msg = $formmail->ErrorInfo;
				}
										
			} else {
				if (!$formready) {
					$this->msg = WH_Lang::_('WH_FORMNOTCOMPLETE', false);	
				} elseif (!$validemail) {
					$this->msg = WH_Lang::_('WH_UNVALIDEMAIL', false);	
				}
			}
			
		} else {			
			$this->msg = WH_Lang::_("WH_FORMERROR", false);			
		}
		
		$this->tmpl = "default";
		$this->render();
	}
	
	/**
	 * Dave Child's blog at ILoveJackDaniel's (ilovejackdaniels.com), shown in Listing 2 (www.ilovejackdaniels.com/php/email-address-validation)
	 *
	 * @param string $email
	 * @return boolean
	 */
	function check_email_address($email) {
	  // First, we check that there's one @ symbol, 
	  // and that the lengths are right.
	  if (!ereg("^[^@]{1,64}@[^@]{1,255}$", $email)) {
	    // Email invalid because wrong number of characters 
	    // in one section or wrong number of @ symbols.
	    return false;
	  }
	  // Split it into sections to make life easier
	  $email_array = explode("@", $email);
	  $local_array = explode(".", $email_array[0]);
	  for ($i = 0; $i < sizeof($local_array); $i++) {
	    if
	(!ereg("^(([A-Za-z0-9!#$%&'*+/=?^_`{|}~-][A-Za-z0-9!#$%&
	?'*+/=?^_`{|}~\.-]{0,63})|(\"[^(\\|\")]{0,62}\"))$",
	$local_array[$i])) {
	      return false;
	    }
	  }
	  // Check if domain is IP. If not, 
	  // it should be valid domain name
	  if (!ereg("^\[?[0-9\.]+\]?$", $email_array[1])) {
	    $domain_array = explode(".", $email_array[1]);
	    if (sizeof($domain_array) < 2) {
	        return false; // Not enough parts to domain
	    }
	    for ($i = 0; $i < sizeof($domain_array); $i++) {
	      if
	(!ereg("^(([A-Za-z0-9][A-Za-z0-9-]{0,61}[A-Za-z0-9])|
	?([A-Za-z0-9]+))$",
	$domain_array[$i])) {
	        return false;
	      }
	    }
	  }
	  return true;
	}
	
}
?>