<?php
/**
 * Cambio v0.5a
 * 
 * http://cambiocms.org/
 * @package Cambio
 */
if (defined("CAMBIO") or die("Access error"));

class WH_AdminModuleGallery extends WH_AdminModule {
	
	function edit() {
		global $db, $wh;
		
		$mid = WH_Helper::get('modid');
		$eid = WH_Helper::get('elmid');
				
		if ($eid) {
			$db->select("SELECT * FROM mod_gallery WHERE id = $eid");
			$this->results = (object) $db->get_row();
		}
		
		$this->pages = $wh->pages;
							
		$this->render();
	}
	
	function add() {
		global $db;
		
		// get thumb size and method from other items from this gallery
		$db->select("SELECT * FROM mod_gallery WHERE module = $this->id");
		$temp = (object) $db->get_row();
		
		$this->results->thumb_size = $temp->thumb_size;
		$this->results->thumb_method = $temp->thumb_method;		
		
		$this->tmpl = "edit";
		$this->edit();
	}
	
	function order() {
		global $db;
		
		if ($this->id) {
			$db->select("SELECT * FROM mod_gallery WHERE module = $this->id ORDER BY ordering");
			$this->data = $db->get_obj();
		}
			
		$this->render();
	}
	
	function save() {
		global $db, $wh;
		
		$post = WH_Helper::get('*', 'post');
		
		// all fields filled in?
		if ( !$post["file"] ) {
			WH_HTML::writeError('Vul alle velden in!<br/><br/>'.WH_HTML::hideAdminButton("Oops!"), true);
		}
				
		$parameters = $this->getParameterArray($post);
		$this->saveParameters($parameters, $post["module"]);
		
		$editor = WH_Helper::getPlugin("media");
		$editor->unsetUploadFields($post);
		
		$global = $post["thumb_global"];
		unset($post["thumb_global"]);
		
		if ($global=="true") {
			$db->update_array("mod_gallery", Array("thumb_method"=>$post["thumb_method"], "thumb_size"=>$post["thumb_size"]), "module = ".$post["module"]);
		}
		
		if ($post["id"]) {
			$db->update_array("mod_gallery", $post, "id = ".$post["id"]);
		} else {
			$post["id"] = null;
			$db->insert_array("mod_gallery", $post);
		}
				
		echo $this->hideAdminCode();
	}
	
	function delete($batch = false) {
		global $db;
		
		if ($this->hasLinks() > 0) {
			die(WH_HTML::delModWarning($this->titel));
		}
		
		$id = WH_Helper::get('modid');
		$db->update_sql("DELETE FROM mod_gallery WHERE module = $id");
		$db->update_sql("DELETE FROM module WHERE id = $id");

		if (!$batch) { echo $this->hideAdminCode(); }
	}
	
	function delete_item() {
		global $db;
		
		$id = WH_Helper::get('elmid');
		$db->update_sql("DELETE FROM mod_gallery WHERE id = $id");
		
		echo $this->hideAdminCode();
	}

	function saveorder() {
		global $db;
		
		$post = WH_Helper::get('*', 'post');
		$sleeporder = WH_Helper::get('sleeporder', 'get');
		if ($sleeporder != "ja") {
			//$parameters = $this->getParameterArray($post);
			//$this->saveParameters($parameters, $post["module"]);
		}
		$post = $post["galleryitem"];

		foreach ($post as $k => $v) {
			$db->update_array("mod_gallery", (object) Array("ordering"=>$v), "id = $k");	
		}
		
		if ($sleeporder == "ja") {
			echo "Gallery ordering saved...";
			exit();
		} else {	
			echo $this->hideAdminCode();
		}
	}		
}
?>