<?php
/**
 * Cambio v0.5a
 * 
 * http://cambiocms.org/
 * @package Cambio
 */
if (defined("CAMBIO") or die("Access error"));

class WH_AdminModuleLayout extends WH_AdminModule {
	
	function manager() {
		global $wh;
		
		$this->layouts = $wh->layouts;
		
		$this->render("manager");
	}
	
	function edit() {
		global $wh;
		$elmid = WH_Helper::get("elmid", "get");
		
		if ($elmid) {		
			$this->layout = $wh->layouts->$elmid;
		}
		
		// look for directories tmpl directory
		$includes = scandir('../tmpl/');
		foreach ($includes as $file) {
			if (strpos($file,".")===false && $file != "_default") {
				$this->templates[] = $file;
			}
		}
		
		$this->render("edit");
	}
		
	function add() {
		$this->edit();
	}
	
	function save() {		
		global $db, $wh;
		
		$post = WH_Helper::get('*', 'post');
		
		if ((!$post["id"] && !$post["name"]) || !$post["tmpl"]) {
			$this->msg = WH_Lang::_("WHADMIN_INFORMATIONMISSING");
			$this->manager();
			return;
		}
						
		if ($post["id"]) {
			// update			
			$db->update_array("layout", $post, "id = ".$post["id"]);
			$this->msg = WH_Lang::_("WHADMIN_LAYOUTUPDATED");
			unset($wh->layouts->{$post["id"]});
			// add layout to mainframe
			$wh->layouts->addLayout($post["id"], $post["name"], $post["tmpl"]);
		} else {
			// new!			
			$post["id"] = null;
			$id = $db->insert_array("layout", $post);
			// add layout to mainframe
			$wh->layouts->addLayout($id, $post["name"], $post["tmpl"]);
			$this->msg = WH_Lang::_("WHADMIN_LAYOUTADDED");
		}
		
		$this->manager();
	}
	
	function delete() {
		global $db, $wh;
		
		$id = WH_Helper::get("elmid", "get");
		
		if ($id) {
			$db->update_sql("DELETE FROM layout WHERE id = $id");
			$db->update_sql("DELETE FROM layout_items WHERE layout = $id");
			$this->msg = WH_Lang::_("WHADMIN_LAYOUTDELETED");
			unset($wh->layouts->{$id});
		}
		
		$this->manager();
	}
	
	function copy() {
		global $wh, $db;
		$elmid = WH_Helper::get("elmid", "get");
		
		if ($elmid) {		
			// get data
			$post = (array) $wh->layouts->$elmid;			
			unset($post["items"]);
			
			$post["id"] = null;
			$post["name"] = $post["name"] . "-copy";
			$id = $db->insert_array("layout", $post);
			
			// add layout to mainframe
			$wh->layouts->addLayout($id, $post["name"], $post["tmpl"]);
			
			foreach ($wh->layouts->$elmid->items as $item) {
				$postitem = (array) $item;
				
				$postitem["id"] = null;
				$postitem["layout"] = $id;
				$itemid = $db->insert_array("layout_items", $postitem);
				
				// add layout to mainframe
				$wh->layouts->addLayoutItem($itemid, $postitem["layout"], $postitem["type"], $postitem["module"], $postitem["pos"], $postitem["replaceable"]);
			}
			
			// set elmid for edit template
			WH_Helper::set("elmid", $id, "get");
			
			// add layout to mainframe
			$wh->layouts->addLayout($id, $post["name"], $post["tmpl"]);
			
			$this->msg = WH_Lang::_("WHADMIN_LAYOUTCOPIED");
			$this->edit();
		}
	}
	
	function setdefault() {
		global $db, $wh;
		
		$id = WH_Helper::get("elmid", "get");
		
		if ($id) {
			$db->update_sql("UPDATE pagina SET layout = $id");
			$this->msg = WH_Lang::_("WHADMIN_DEFAULTSET");
		}
		
		$this->manager();
	}
	
	function edititem() {
		global $wh;
		$elmid = WH_Helper::get("elmid", "get");
				
		if ($elmid && !isset($this->layoutid)) {
			$this->item = $wh->layouts->getLayoutItem($elmid);
			$this->layoutid = $wh->layouts->getLayoutIdOfItem($elmid);
			global $cd;
			$cd->onload[] = "setLayoutType(".$this->item->type.")";
		}

		// for new modules
		$this->modules = $wh->modules->getModulesXML();
		$this->positions = $wh->modules->getPosXML();	
		
		// for linked modules
		$this->linkmodules = $wh->modules;
		$this->linkpages = $wh->pages;
				
		$this->render("edititem");
	}
	
	function additem() {
		global $wh;
		$elmid = WH_Helper::get("elmid", "get");
		
		if ($elmid) {
			$this->layoutid = $elmid;
			$this->edititem();
		}		
	}
	
	function deleteitem() {
		global $db, $wh;
		
		$id = WH_Helper::get("elmid", "get");
		
		$layoutid = $wh->layouts->getLayoutIdOfItem($id);
		WH_Helper::set("elmid", $layoutid, "get");
		
		if ($id) {
			$db->update_sql("DELETE FROM layout_items WHERE id = $id");
			$this->msg = WH_Lang::_("WHADMIN_ITEMDELETED");
			unset($wh->layouts->{$layoutid}->items->$id);
		}
		
		$this->edit();
	}
	
	function saveitem() {
		global $db, $wh;
		
		$post = WH_Helper::get('*', 'post');
		
		WH_Helper::set("elmid", $post["layout"], "get");
		
		if (($post["type"] == "0" && (!$post["newmodule"] || !$post["pos"])) ||
			($post["type"] == "1" && !$post["linkmodule"])) {				
			$this->msg = WH_Lang::_("WHADMIN_INFORMATIONMISSING");
			$this->edit();
			return;
		}
		
		if ($post["type"]=="0") {
			$post["module"] = $post["newmodule"];
		} else {
			$post["module"] = $post["linkmodule"];
			$post["pos"] = "";
		}
		unset($post["newmodule"]);
		unset($post["linkmodule"]);	
								
		if ($post["id"]) {
			// update			
			$db->update_array("layout_items", $post, "id = ".$post["id"]);
			$this->msg = WH_Lang::_("WHADMIN_ITEMUPDATED");
			unset($wh->layouts->{$post["layout"]}->items->{$post["id"]});
			// add layout item to mainframe
			$wh->layouts->addLayoutItem($post["id"], $post["layout"], $post["type"], $post["module"], $post["pos"], $post["replaceable"]);
		} else {
			// new!			
			$post["id"] = null;
			$id = $db->insert_array("layout_items", $post);
			// add layout item to mainframe
			$wh->layouts->addLayoutItem($id, $post["layout"], $post["type"], $post["module"], $post["pos"], $post["replaceable"]);
			$this->msg = WH_Lang::_("WHADMIN_ITEMADDED");
		}
		
		$this->edit();
	}
	
}
?>