<?php
/**
 * Cambio v0.5a
 * 
 * http://cambiocms.org/
 * @package Cambio
 */
if (defined("CAMBIO") or die("Access error"));

class WH_AdminModuleMenu extends WH_AdminModule {
	
	function edit() {
		global $db, $wh;
		
		$mid = WH_Helper::get('modid');
		$eid = WH_Helper::get('elmid');
				
		if ($eid) {
			$db->select("SELECT * FROM mod_menu WHERE id = $eid");
			$this->data = (object) $db->get_row();
		} else {
			$this->data->style = $db->select_one("SELECT style FROM mod_menu WHERE module = $mid");
		}
		
		$this->pages = $wh->pages->getPagesTree(null, true);						
		$this->render();
	}
	
	function add() {
		$this->tmpl = "edit";
		$this->edit();
	}
	
	function order() {
		global $db;
		
		if ($this->id) {
			$db->select("SELECT * FROM mod_menu WHERE module = $this->id ORDER BY ordering");
			$this->data = $db->get_obj();
		}
			
		$this->render();
	}
	
	function saveorder() {
		global $db;
		
		$post = WH_Helper::get('*', 'post');
		$sleeporder = WH_Helper::get('sleeporder', 'get');
		if ($sleeporder != "ja") {
			$this->saveParameters($post, "menu");
		}
		
		$post = $post["menuitem"];
		foreach ($post as $k => $v) {
			$db->update_array("mod_menu", (object) Array("ordering"=>$v), "id = $k");	
		}
		
		$style = (int) WH_Helper::get('style', 'post');
		if (!is_null($style)) {
			$db->update_array("mod_menu", (object) Array("style"=>$style), "module = ".WH_Helper::get('module', 'post'));	
		}
		
		if ($sleeporder == "ja") {
			echo "Menuitems ordering saved...";
			exit();
		} else {	
			echo $this->hideAdminCode();
		}
	}
	
	function save() {
		global $db, $wh;
		
		$post = WH_Helper::get('*', 'post');
		
		// all fields filled in?
		if ( (substr($post["titel"],0,2)!="--" && !$post["pagina"]) || !$post["titel"] ) {
			WH_HTML::writeError('Vul alle velden in!<br/><br/>'.WH_HTML::hideAdminButton("Oops!"), true);
		}
		
		if ($post["id"]) {
			$db->update_array("mod_menu", $post, "id = ".$post["id"]);
		} else {
			$post["id"] = null;
			$db->insert_array("mod_menu", $post);
		}
		
		/* @var $module WH_Module */
		$module = WH_Modules::getInstance($post["module"]);
		$this->setTitle("menu in ".$module->pos." op pagina ".$wh->pages->{$module->pagina}->titel, $post["module"]);
		//exit();
		echo $this->hideAdminCode();
	}
	
	function delete($batch = false) {
		global $db;
		
		if ($this->hasLinks() > 0) {
			die(WH_HTML::delModWarning($this->titel));
		}
		
		$id = WH_Helper::get('modid');
		$db->update_sql("DELETE FROM mod_menu WHERE module = $id");
		$db->update_sql("DELETE FROM module WHERE id = $id");
		
		if (!$batch) { echo $this->hideAdminCode(); }
	}
	
	function delete_item() {
		global $db;
		
		$id = WH_Helper::get('elmid');
		$db->update_sql("DELETE FROM mod_menu WHERE id = $id");
		
		echo $this->hideAdminCode();
	}
	
}
?>