<?php
/**
 * Cambio v0.5a
 * 
 * http://cambiocms.org/
 * @package Cambio
 */
if (defined("CAMBIO") or die("Access error"));

class WH_AdminModulePages extends WH_AdminModule {
	
	function edit() {
		global $db, $wh;
		
		$pid = WH_Helper::get('elmid');
		
		if ($pid) {
			$db->select("SELECT * FROM pagina WHERE id = $pid");
			$this->data = (object) $db->get_row();
		}
		
		$tmpls = Array();
		// add all layouts in mainframe to var
		foreach ((array) $wh->layouts as $layout) {
			$tmpls[] = $layout->tmpl;
		}
		
		// check if all tmpl have a layout
		$includes = scandir('../tmpl/');
		foreach ($includes as $file) {
			if (strpos($file,".")===false && $file != "_default") {
				if (!in_array($file, $tmpls)) {
					// add layout to database
					$lid = $db->insert_array("layout", Array("name"=>$file, "tmpl"=>$file));
					// add layout to mainframe
					$wh->layouts->addLayout($lid, $file, $file);
				}				
			}
		}
		
		// get layouts
		$this->layouts = $wh->layouts->getLayouts();
		
		// get pages
		$this->pages = $wh->pages->getPagesTree(null, true);
				
		$this->render();
	}
	
	function add() {
		global $wh;
		// get default page
		foreach ($wh->pages as $page) {
			if ($page->layout <> $layout && isset($layout)) {
				$layout = "";
				break;
			} else {
				$layout = $page->layout;
			}
		}
		$this->data->layout = $layout;
		$this->tmpl = "edit";
		$this->edit();
	}
	
	function save() {
		global $db;
		
		$post = WH_Helper::get('*', 'post');
		
		if ($post["id"]) {
			$db->update_array("pagina", $post, "id = ".$post["id"]);
		} else {
			$menulink = $post["menulink"];			
			unset($post["menulink"]);
			$post["id"] = null;
			$id = $db->insert_array("pagina", $post);
			if ($menulink) {
				$db->insert_array("mod_menu",Array("module"=>$menulink, "titel"=>$post["titel"], "pagina"=>$id));
			}
		}
		echo $this->hideAdminCode();
	}
	
	function delete() {
		global $db;
		
		$id = WH_Helper::get('elmid');
		
		// loop through modules for page
		$db->select("SELECT * FROM module WHERE pagina = $id");
		$res = $db->get_obj();
		
		// remove modules for page
		foreach ($res as $item) {
			/* @var $module WH_Module */
			$module = WH_Modules::getInstance($item->id);
			$module->loadModule("../", true);			
			$className = "WH_Module".$item->module;
			$tmp = New $className($module);
			WH_Helper::set('modid', $tmp->id);
			// script will end if links are found
			$tmp->delete(true);
		}
		
		$db->update_sql("DELETE FROM module WHERE pagina = $id");
		$db->update_sql("DELETE FROM pagina WHERE id = $id");
		
		global $cf;
		?>
		<script language="javascript">document.location.href = '<?php echo WH_HTML::buildURL($cf->whHomepage);?>';</script>
		<?php
		//echo $this->hideAdminCode();
	}
	
	function order() {
		$this->render();
	}

	
}
?>