<?php
/**
 * Cambio v0.5a
 * 
 * http://cambiocms.org/
 * @package Cambio
 */
if (defined("CAMBIO") or die("Access error"));

class WH_AdminModuleUser extends WH_AdminModule {
	
	function checkUser() {
		global $db;
		
		$username = WH_Helper::get("username", "get");
		if ($db->select_one("SELECT users.id FROM users WHERE users.user = '$username'")) {
			echo "<span style=\"color: red;\">".WH_Lang::_("WHADMIN_NOTAVAILABLE")."</span>";
		} else {
			echo "<span style=\"color: green;\">".WH_Lang::_("WHADMIN_AVAILABLE")."</span>";
		}
		
		// ajax response, exit to prevent footer etc to being echoed
		exit();		
		
	}
	
	function manager() {
		global $db;
		
		if (!$this->id) {
			$this->id = WH_Helper::get("module", "post");
		}
		
		$db->select("SELECT users.*, usertypes.usertype, usertypes.isadmin FROM users INNER JOIN usertypes ON users.usertype_id = usertypes.id ORDER BY user");
		$this->users = $db->get_obj();
		
		$db->select("SELECT usertypes.*, COUNT(users.id) AS users_with_type FROM usertypes LEFT JOIN users ON usertypes.id = users.usertype_id GROUP BY usertypes.id ORDER BY usertypes.usertype
");
		$this->usertypes = $db->get_obj();
		
		$this->render("manager");
	}
	
	function edituser() {
		global $db, $cd;
		
		$userid = WH_Helper::get("elmid");
		
		$db->select("SELECT users.*, usertypes.usertype, usertypes.isadmin FROM users INNER JOIN usertypes ON users.usertype_id = usertypes.id WHERE users.id = $userid");
		$this->user = (object) $db->get_row();
		
		$db->select("SELECT * FROM usertypes ORDER BY isadmin, usertype");
		$this->types = $db->get_array();
		
		$this->render();
	}
	
	function adduser() {
		global $db, $cd;
				
		$db->select("SELECT * FROM usertypes ORDER BY isadmin, usertype");
		$this->types = $db->get_array();
		
		$this->render("edituser");
	}
	
	function deluser() {
		global $db;
		
		$userid = WH_Helper::get("elmid");

		if ($db->select_one("SELECT users.user FROM users WHERE users.id = $userid") == "admin") {
			$this->msg = WH_Lang::_("WHADMIN_NOADMINUSERDELETE");
			$this->manager();
			return;
		}
		
		$db->update_sql("DELETE FROM users WHERE id = $userid");
		
		$this->msg = WH_Lang::_("WHADMIN_USERDELETED");;
		
		$this->manager();
	}
	
	function save() {
		global $db, $cd;
		
		$post = WH_Helper::get('*', 'post');
		
		if ((!$post["id"] && !$post["user"]) || !$post["usertype_id"]) {
			$this->msg = WH_Lang::_("WHADMIN_INFORMATIONMISSING");
			$this->manager();
			return;
		}
		
		if ($post["newpass1"] != $post["newpass2"]) {
			$this->msg = WH_Lang::_("WHADMIN_PASSWORDSNOTTHESAME");
			$this->manager();
			return;
		}
		
		unset($post["module"]);
		
		if ($post["id"]) {
			// update
			if ($post["newpass1"]) {
				// newpass
				$post["pass"] = md5($post["newpass1"]);
			} else {
				unset($post["pass"]);
			}
			unset($post["newpass1"]);
			unset($post["newpass2"]);
			$db->update_array("users", $post, "id = ".$post["id"]);
		} else {
			// new!
			if ($db->select_one("SELECT users.id FROM users WHERE users.user = '".$post["user"]."'")) {
				$this->msg = WH_Lang::_("WHADMIN_USERNAMEDUPLICATE");
				$this->manager();
				return;
			}
			if ($post["newpass1"]) {
				$post["pass"] = md5($post["newpass1"]);
				unset($post["newpass1"]);
				unset($post["newpass2"]);
			} else {
				$this->msg = WH_Lang::_("WHADMIN_PASSWORDMISSING");
				$this->manager();
				return;
			}
			$post["id"] = null;
			$db->insert_array("users", $post);
		}
		
		$this->msg = WH_Lang::_("WHADMIN_USERSAVED");

		$this->manager();
	}
	
	function edittype() {
		global $db, $cd;
		
		$typeid = WH_Helper::get("elmid");
		
		$db->select("SELECT usertypes.* FROM usertypes WHERE usertypes.id = $typeid");
		$this->usertype = (object) $db->get_row();
				
		$this->render();
	}
	
	function addtype() {
		$this->render("edittype");
	}
	
	function deltype() {
		global $db;
		
		$typeid = WH_Helper::get("elmid");
		
		$db->select("SELECT COUNT(users.id) AS users_with_type FROM usertypes LEFT JOIN users ON usertypes.id = users.usertype_id WHERE usertypes.id = $typeid GROUP BY usertypes.id");
		$this->countusers = $db->get_row();
		if ($this->countusers["users_with_type"]>0) {
			$this->msg = WH_Lang::_("WHADMIN_USERTYPEGOTUSERS");
			$this->manager();
			return;
		}
		
		$db->update_sql("DELETE FROM usertypes WHERE id = $typeid");
		
		$this->msg = WH_Lang::_("WHADMIN_USERTYPEDELETED");
		
		$this->manager();
	}
	
	function savetype() {
		global $db, $cd;
		
		$post = WH_Helper::get('*', 'post');
		
		if ((!$post["id"] && !$post["usertype"]) || !isset($post["isadmin"])) {
			$this->msg = WH_Lang::_("WHADMIN_INFORMATIONMISSING");
			$this->manager();
			return;
		}		
		
		unset($post["module"]);
		
		if ($post["id"]) {
			// update			
			$db->update_array("usertypes", $post, "id = ".$post["id"]);
		} else {
			// new!		
			$post["id"] = null;
			$db->insert_array("usertypes", $post);
		}
		
		$this->msg = WH_Lang::_("WHADMIN_USERTYPESAVED");

		$this->manager();
	}
	
}
?>