<?php
/**
 * Cambio v0.5a
 * 
 * http://cambiocms.org/
 * @package Cambio
 */
if (defined("CAMBIO") or die("Access error"));

class WH_PluginMedia {
	
	/**
	 * Plugin class for WH website
	 *
	 * @return WH_PluginMedia
	 */
	function WH_PluginMedia() {
		// initialize
		return true;
	}
	
	function writeMediaModule(
		$dir,		
		$size = 10,
		$showupload = true,
		$filter = "jpg|png|gif",
		$jsfunc = "do_image") {
		
		global $cf;
		
		// buttontext
		if (is_null($buttontext)) {
			$buttontext = WH_Lang::_('WHADMIN_SELECT', false, 'plugins/media');
		} ?>
		
		<div class="sidebar-title">
			<?php echo WH_Lang::_('WHADMIN_MEDIA', false, 'plugins/media'); ?>
		</div>
		<div class="sidebar-item">
			<div id="medialist">
			<?php
			$this->writeMediaList('../media', '../media/'.$dir, 0, $filter, $jsfunc); ?>
			</div>
			<?php
			if ($showupload) {
				$this->writeUploadForm($dir, $filter, $jsfunc);
			}?>
		</div>
		<script type="text/javascript" language="javascript">setTimeout("loadThumb('<?php echo $this->stripFilename('../media/'.$dir);?>','<?php echo '../media/'.$dir; ?>');",1000);</script>
		<?php
	}
	
	function writeMediaList($pth, $default = NULL, $lev = 0, $filter = "*", $jsfunc = "do_image") {
		
		$ignore = array( 'cgi-bin', '.', '..' );// Directories to ignore
		if (!is_array($filter)) { $filter = explode("|",strtolower($filter)); }
	    $dh = @opendir( $pth );
	    
	    if ($lev > 0) { 
		    echo "<div class=\"dirwrapper\" id=\"".$this->stripFilename($pth)."\"";
		    if ($pth == $default || strstr($default, $pth) !== false) {
		    	echo " style=\"display: block;";
		    } else {
		    	echo " style=\"display: none;";
		    }
		    echo "margin-left: ".($lev*10)."px;\">";
	    }
	    
	    $filescount = 0;
	    while( false !== ( $file = readdir( $dh ) ) ){
	    	
	        if( !in_array( $file, $ignore ) ){	        	
	        	
	            if( is_dir( "$pth/$file" ) ){
	            	
	            	echo "<div class=\"dir\">";
	            	echo "<a href=\"javascript:void(null)\" onclick=\"toggleDir('".$this->stripFilename($pth.'/'.$file)."','".$pth."/".$file."');\">$file</a>";
	            	echo "</div>";	            	
	            	
	            	$filescount++;
	            	
	                $this->writeMediaList( "$pth/$file", $default, ($lev+1), $filter, $jsfunc );            
	                
	            } else {
	            	
	            	if (in_array(strtolower(substr("$pth/$file", strrpos("$pth/$file", '.') + 1)), $filter) || $filter[0] == "*") {
	            		
		            	echo "<a class=\"file\" href=\"javascript:void(null)\" onclick=\"$jsfunc('".str_replace("../media/","",$pth."/".$file)."')\">";
		                echo "$file";
		                echo "</a>";
		                
		                $filescount++;
		                
	            	}
	                
	            }	            
	        }
	    }
	    
	    if ($filescount == 0) {
	    	echo WH_Lang::_("WHADMIN_NOFILESFOUND", false, 'plugins/media');
	    }
	    
	    if ($lev > 0) { 
	    	echo "</div>";
	    }
	    
	    closedir( $dh );
		
	}
	
	function writeUploadForm($dir, $filter, $jsfunc) {
		$formlimit = 10; // MB
		/**
		 * This upload size can be limited in PHP.INI
		 * try to append/create in the .htaccess file in the root:
		 * 		php_value upload_max_filesize 10M 
		 * 		php_value post_max_size 20M
		 */
		?>
		
		<script type="text/javascript">addJavascript('<?php echo "plugin/media/js/ajaxfileupload.js"; ?>');</script>
		<script type="text/javascript">addJavascript('<?php echo "plugin/media/js/uploadhelper.js"; ?>');</script>	
		<h3><?php echo WH_Lang::_("WHADMIN_UPLOAD",false,"plugins/media");?></h3>
	
		<!-- Firefox thing: no form in form //-->
		<!-- This must be working also      //-->
		<!--<form action="index.php" method="post" enctype="multipart/form-data">//-->
			<input type="hidden" name="MAX_FILE_SIZE" value="<?php echo $formlimit * 1000000; ?>" />
			<input type="hidden" name="fileUploadDir" id="fileUploadDir" value="<?php echo $dir; ?>"  />
			<input type="hidden" name="fileFilter" id="fileFilter" value="<?php echo $filter; ?>" />
			<input type="hidden" name="jsFunc" id="jsFunc" value="<?php echo $jsfunc; ?>" />
			
			<div class="fileinputs">
				<input id="fileToUpload" type="file" name="fileToUpload" onchange="return ajaxFileUpload();" />
				<div class="fakefile">
					<button onclick="return false;"><?php echo WH_Lang::_("WHADMIN_BROWSE", false, "plugins/media"); ?></button>
					<img id="loading" src="tmpl/_default/images/general/ajax.gif" style="display:none;" />
				</div>
			</div>
			
			<!--<button id="buttonUpload" onclick="return ajaxFileUpload();">Upload</button>//-->
			<!--<img id="loading" src="tmpl/_default/images/general/ajax.gif" style="display:none;" />//-->
		<!--</form>//-->
		<?php
		$postmax = intval(ini_get('post_max_size'));
		$uploadmax = intval(ini_get("upload_max_filesize"));
		if ($postmax > $uploadmax) { $limit = $uploadmax; } else { $limit = $postmax; }
		if ($limit > $formlimit) { $limit = $formlimit; }
		echo "<br/>".WH_Lang::_('WHADMIN_UPLOADLIMIT', false, 'plugins/media').": $limit MB.";
	}
	
	function unsetUploadFields(&$post) {
		unset($post["MAX_FILE_SIZE"]);
		unset($post["fileUploadDir"]);
		unset($post["fileFilter"]);
		unset($post["fileToUpload"]);
		unset($post["jsFunc"]);
	}
	
	function stripFilename($pth) {
		return str_replace(".","",str_replace("/","",$pth));
	}
		
	function saveUpload($dir = 'files', $filter = '*') {
		
		// TODO: check if file exists
		
		ob_clean();
		$target_path = "../media/$dir/";	
		$target_path = $target_path . basename( $_FILES['fileToUpload']['name']); 
		
		$filename = $_FILES['fileToUpload']['name'];
		$fileext = strtolower(substr($filename, strrpos($filename, '.') + 1));
		
		$filter = explode("|", strtolower($filter));
		$bad_files = array('exe', 'php', 'php3', 'php4', 'ph3', 'ph4', 'perl', 'cgi', 'bin', 'scr', 'bat', 'pif', 'aps', 'ssi', 'swf', 'js');
		
		if (!in_array($fileext, $filter) && $filter[0] != "*") {
			$error = "File ".  basename( $_FILES['fileToUpload']['name']). " has no valid extension. ";
			$error .= "Valid extensions are: ".implode(", ",$filter);
		} elseif (in_array($fileext, $bad_files)) {
			$error = "File ".  basename( $_FILES['fileToUpload']['name']). " has a forbidden extension. ";
			$error .= "Forbidden extensions are: ".implode(", ",$bad_files);
		} else {
			if(move_uploaded_file($_FILES['fileToUpload']['tmp_name'], $target_path)) {
				chmod($target_path, 0777);
			    $msg = "File ".  basename( $_FILES['fileToUpload']['name']). " uploaded";
			} else{
		        switch ($_FILES['fileToUpload']['error']) {
		        	case '1':
						$error = 'The uploaded file exceeds the upload_max_filesize directive in php.ini';
						break;
					case '2':
						$error = 'The uploaded file exceeds the MAX_FILE_SIZE directive that was specified in the HTML form';
						break;
					case '3':
						$error = 'The uploaded file was only partially uploaded';
						break;
					case '4':
						$error = 'No file was uploaded.';
						break;		
					case '6':
						$error = 'Missing a temporary folder';
						break;
					case '7':
						$error = 'Failed to write file to disk';
						break;
					case '8':
						$error = 'File upload stopped by extension';
						break;
		            default:
		            	$error = 'Uploading of file failed.';
		         }
			}
		}
		echo "{";
		echo				"error: '" . $error . "',\n";
		echo				"msg: '" . $msg . "',\n";
		echo 				"file: '" . $filename . "'\n";
		echo "}";
		exit();
				
	}
	
}